--		Fast polygon fillers + a bunch of misc. routines for Euphoria 2.0+
--						  v. 00.05.20
--					      Mic, 1999/2000

without warning
include asm.e


--*** Variables for use with hline drawers ***--
global constant asm_xmin=allocate(768*4*8),
                asm_xmax=asm_xmin+(768*4),
                asm_cmin=asm_xmin+(768*4*2),
                asm_cmax=asm_xmin+(768*4*3),
                asm_umin=asm_xmin+(768*4*4),
                asm_umax=asm_xmin+(768*4*5),
                asm_vmin=asm_xmin+(768*4*6),
                asm_vmax=asm_xmin+(768*4*7),
                REGULAR=1,MIXED=2,TILED=3
constant rScreenW=allocate(4),rScreenH=allocate(4),rDummy=allocate(4),
         rMaxW=allocate(4),rMaxH=allocate(4),
         hl24_color=allocate(4),rClip=allocate(16),
         rFlatY=allocate(32),rFlatNumLines=rFlatY+4,rFlatColor=rFlatY+8,
         rFlatScrAddr=rFlatY+12,rFlatCode=rFlatY+16,
         rBytesOnScreen=rFlatY+20,rFCopyIter=rFlatY+24,rClsIter=rFlatY+28,
         texY=1,texNumLines=2,texScrAddr=3,texTexture=4,texCode=5,texScan=6 

integer render_screenW,render_maxW
integer render_screenH,render_maxH
integer render_bytesPerPixel,render_clipping
atom flat_numlines,flat_y,flat_scraddr,flat_color,flat_code
atom mixflat_numlines,mixflat_y,mixflat_scraddr,mixflat_color,mixflat_code
global atom gouraud_scan_routine,gouraud_scan_data,gouraud_hlines,gouraud_y,gouraud_numlines,
            gouraud_scraddr
atom mixgouraud_numlines,mixgouraud_y,mixgouraud_scraddr,mixgouraud_hlines
atom texture_numlines,texture_y,texture_scraddr,texture_texture,texture_code
atom mixtexture_numlines,mixtexture_y,mixtexture_scraddr,mixtexture_texture,mixtexture_code
atom tiledtexture_numlines,tiledtexture_y,tiledtexture_scraddr,tiledtexture_texture,tiledtexture_code
atom rMixTb
sequence mapping

mapping={0,0,0,0,0}
render_clipping=0

procedure poke_word(atom dest,object word)
 if sequence(word) then
  for i=1 to length(word) do
   poke(dest+((i-1)*2),and_bits(word[i],#00FF))
   poke(dest+((i-1)*2)+1,floor(and_bits(word[i],#FF00)/256))
  end for
 else
  poke(dest,and_bits(word,#00FF))
  poke(dest+1,floor(and_bits(word,#FF00)/256))
 end if
end procedure

function peek_word(atom src)
integer ret
 ret=peek(src+1)*256
 ret=or_bits(ret,peek(src))
 return ret
end function

procedure poke3(atom dest,object word)
 if sequence(word) then
  for i=1 to length(word) do
   poke(dest+((i-1)*2),and_bits(word[i],#00FF))
   poke(dest+((i-1)*2)+1,floor(and_bits(word[i],#FF00)/256))
   poke(dest+((i-1)*2)+2,floor(and_bits(word[i],#FF0000)/65536))
  end for
 else
  poke(dest,and_bits(word,#00FF))
  poke(dest+1,floor(and_bits(word,#FF00)/256))
  poke(dest+2,floor(and_bits(word,#FF0000)/65536))
 end if
end procedure

function peek3(atom src)
integer ret
 ret=peek(src+2)*65536
 ret=or_bits(ret,peek(src+1)*256)
 ret=or_bits(ret,peek(src))
 return ret
end function


--** <Assembly code> **--
--** <Poly fillers> **--

--** draw a number of horizontal lines with constant color **--
global constant hl_code=get_asm(
"pusha cld "&
"mov ecx,hl_numlines "&
"mov ebp,hl_y "&
"mov eax,[hl_screenW] "&
"lea ebx,[ebp*4] "&
"mul ebp "&
"mov ebp,eax "&
"hl_@yloop: "&
"push ecx "&
"mov edi,hl_scraddr "&
"add edi,ebp "&
"mov eax,[asm_xmin + ebx] "&
"cmp eax,[hl_maxW] "&
"jg hl_@skip "&
"cmp eax,0 "&
"jnl hl_@xmin_nl_0 "&
"mov eax,0 "&
"hl_@xmin_nl_0: "&
"mov ecx,[asm_xmax + ebx] "&
"cmp ecx,0 "&
"jl hl_@skip "&
"cmp ecx,[hl_maxW] "&
"jng hl_@xmax_ng_maxW "&
"mov ecx,[hl_maxW] "&
"hl_@xmax_ng_maxW: "&
"add edi,eax "&
"sub ecx,eax "&
"inc ecx "&
"mov eax,hl_color "&
"mov esi,ecx "&
"and esi,3 "&
"mov edx,edi "&
"and edx,3 "&			--align on 32-bits if possible
"cmp edx,3 "&
"jne hl_@already_aligned "&
"cmp esi,3 "&
"jne hl_@already_aligned "&	--not really true..
"mov edx,ecx "&
"mov ecx,esi "&
"rep stosb "&
"mov ecx,edx "&
"xor esi,esi "&
"hl_@already_aligned "&
"shr ecx,2 "&
"rep stosd "&
"mov ecx,esi "&
"jz hl_@skip "&
"rep stosb "&
"hl_@skip: "&
"add ebx,4 "&
"pop ecx "&
"add ebp,[hl_screenW] "&
"dec ecx "&
"jnz hl_@yloop "&
"popa ret")
global constant hl_numlines=hl_code+get_param("hl_numlines")
global constant hl_y=hl_code+get_param("hl_y")
global constant hl_scraddr=hl_code+get_param("hl_scraddr")
global constant hl_color=hl_code+get_param("hl_color")
resolve_param("asm_xmax",asm_xmax)
resolve_param("asm_xmin",asm_xmin)
resolve_param("hl_screenW",rScreenW)
resolve_param("hl_maxW",rMaxW)


global constant hl1516_code=get_asm(
"pusha cld "&
"mov ecx,hl16_numlines "&
"mov ebp,hl16_y "&
"lea ebx,[ebp*4] "&
"mov eax,[hl16_screenW] "&
"mul ebp "&
"lea eax,[eax+eax] "&
"mov ebp,eax "&
"mov edx,[hl16_screenW] "&
"hl16_@yloop: "&
"push ecx "&
"mov edi,hl16_scraddr "&
"add edi,ebp "&
"mov eax,[asm_xmin + ebx] "&
"cmp eax,[hl16_maxW] "&
"jg hl16_@skip "&
"cmp eax,0 "&
"jnl hl16_@xmin_nl_0 "&
"mov eax,0 "&
"hl16_@xmin_nl_0: "&
"mov ecx,[asm_xmax + ebx] "&
"cmp ecx,0 "&
"jl hl16_@skip "&
"cmp ecx,[hl16_maxW] "&
"jng hl16_@xmax_ng_maxW "&
"mov ecx,[hl16_maxW] "&
"hl16_@xmax_ng_maxW: "&
"add edi,eax "&
"add edi,eax "&
"sub ecx,eax "&
"inc ecx "&
"mov eax,hl16_color "&
"mov esi,ecx "&
"shr ecx,1 "&
"rep stosd "&
"and esi,1 "&
"jz hl16_@skip "&
"stosw "&
"hl16_@skip: "&
"add ebx,4 "&
"pop ecx "&
"lea ebp,[edx*2 + ebp] "&
"dec ecx "&
"jnz hl16_@yloop "&
"popa ret")
global constant hl1516_numlines=hl1516_code+get_param("hl16_numlines")
global constant hl1516_y=hl1516_code+get_param("hl16_y")
global constant hl1516_scraddr=hl1516_code+get_param("hl16_scraddr")
global constant hl1516_color=hl1516_code+get_param("hl16_color")
resolve_param("asm_xmax",asm_xmax)
resolve_param("asm_xmin",asm_xmin)
resolve_param("hl16_screenW",rScreenW)
resolve_param("hl16_maxW",rMaxW)


global constant hl16_mix_code=get_asm(
"pusha cld "&
"mov ecx,hl16_numlines "&
"mov ebp,hl16_y "&
"lea ebx,[ebp*4] "&
"mov eax,[hl16_screenW] "&
"mul ebp "&
"lea eax,[eax+eax] "&
"mov ebp,eax "&
"mov edx,[hl16_screenW] "&
"hl16_@yloop: "&
"push ecx "&
"mov edi,hl16_scraddr "&
"add edi,ebp "&
"mov eax,[asm_xmin + ebx] "&
"cmp eax,[hl16_maxW] "&
"jg hl16_@skip "&
"cmp eax,0 "&
"jnl hl16_@xmin_nl_0 "&
"mov eax,0 "&
"hl16_@xmin_nl_0: "&
"mov ecx,[asm_xmax + ebx] "&
"cmp ecx,0 "&
"jl hl16_@skip "&
"cmp ecx,[hl16_maxW] "&
"jng hl16_@xmax_ng_maxW "&
"mov ecx,[hl16_maxW] "&
"hl16_@xmax_ng_maxW: "&
"add edi,eax "&
"add edi,eax "&
"sub ecx,eax "&
"inc ecx "&
"mov eax,hl16_color "&
"shr ax,1 and eax,31727 "&
--"mov esi,ecx "&
"lea edi,[edi + ecx*2] "&
"xor ecx,-1 "&
"inc ecx "&
"mov esi,ebx "&
"hl16_mix_@xloop: "&
"mov bx,word ptr [edi + ecx*2] "&
"shr bx,1 and ebx,31727 "&
"add bx,ax "&
"mov [edi + ecx*2],bx "&
"inc ecx "&
"jnz hl16_mix_@xloop "&
"mov ebx,esi "&
"hl16_@skip: "&
"add ebx,4 "&
"pop ecx "&
"lea ebp,[edx*2 + ebp] "&
"dec ecx "&
"jnz hl16_@yloop "&
"popa ret")
global constant hl16_mix_numlines=hl16_mix_code+get_param("hl16_numlines")
global constant hl16_mix_y=hl16_mix_code+get_param("hl16_y")
global constant hl16_mix_scraddr=hl16_mix_code+get_param("hl16_scraddr")
global constant hl16_mix_color=hl16_mix_code+get_param("hl16_color")
resolve_param("asm_xmax",asm_xmax)
resolve_param("asm_xmin",asm_xmin)
resolve_param("hl16_screenW",rScreenW)
resolve_param("hl16_maxW",rMaxW)




global constant hl24_code=get_asm(
"pusha cld "&
"mov ecx,hl24_numlines "&
"mov ebp,hl24_y "&
"lea ebx,[ebp*4] "&
"mov eax,[hl24_screenW] "&
"mul ebp "&
"lea eax,[eax*2 + eax] "&
"mov ebp,eax "&
"mov edx,[hl24_screenW] "&
"hl24_@yloop: "&
"push ecx "&
"mov edi,hl24_scraddr "&
"add edi,ebp "&
"mov eax,[asm_xmin + ebx] "&
"cmp eax,[hl24_maxW] "&
"jg hl24_@skip "&
"cmp eax,0 "&
"jnl hl24_@xmin_nl_0 "&
"mov eax,0 "&
"hl24_@xmin_nl_0: "&
"mov ecx,[asm_xmax + ebx] "&
"cmp ecx,0 "&
"jl hl24_@skip "&
"cmp ecx,[hl24_maxW] "&
"jng hl24_@xmax_ng_maxW "&
"mov ecx,[hl24_maxW] "&
"hl24_@xmax_ng_maxW: "&
"add edi,eax "&
"lea edi,[eax*2+edi] "&
"sub ecx,eax "&
"jz hl24_@odd_pixel "&
"mov eax,[hl24_color] "&
"hl24_@inner: "&
"stosd "&
"dec edi "&
"loop hl24_@inner "&
"hl24_@odd_pixel: "&
"mov eax,[hl24_color] "&
"stosw "&
"shr eax,16 "&
"stosb "&
"hl24_@skip: "&
"add ebx,4 "&
"pop ecx "&
"mov edi,edx "&
"lea edi,[edi*2 +edi] "&
"add ebp,edi "&
"dec ecx "&
"jnz hl24_@yloop "&
"popa ret")
global constant hl24_numlines=hl24_code+get_param("hl24_numlines")
global constant hl24_y=hl24_code+get_param("hl24_y")
global constant hl24_scraddr=hl24_code+get_param("hl24_scraddr")
resolve_param("hl24_color",hl24_color)
resolve_param("asm_xmax",asm_xmax)
resolve_param("asm_xmin",asm_xmin)
resolve_param("hl24_screenW",rScreenW)
resolve_param("hl24_maxW",rMaxW)


--*** Draw a number of shaded horizontal lines (for use with gouraud poly-drawers). ***--
global constant ghl_code=get_asm(
"pusha "&
"cld "&
"mov ecx,ghl_numlines "&
"mov ebp,ghl_y "&
"lea ebx,[ebp*4] "&
"mov eax,[ghl_screenW] "&
"mul ebp "&
"mov ebp,eax "&
"ghl_@yloop: "&
"push ecx "&
"mov edi,ghl_scraddr "&
"add edi,ebp "&
"mov eax,[asm_xmin + ebx] "&
"cmp eax,[ghl_maxW] "&
"jg ghl_@skip "&
"cmp eax,0 "&
"jnl ghl_@xmin_nl_0 "&
"mov eax,0 "&
"ghl_@xmin_nl_0: "&
"mov ecx,[asm_xmax + ebx] "&
"cmp ecx,0 "&
"jl ghl_@skip "&
"cmp ecx,[ghl_maxW] "&
"jng ghl_@xmax_ng_maxW "&
"mov ecx,[ghl_maxW] "&
"ghl_@xmax_ng_maxW: "&
"add edi,eax "&
"sub ecx,eax "&
"inc ecx "&
"mov eax,[asm_cmax + ebx] "&
"sub eax,[asm_cmin + ebx] "&
--"sub eax,edx "&
"cwd "&
"idiv ecx "&
"mov edx,eax "&
"mov eax,[asm_cmin + ebx] "&
"lea edi,[edi + ecx] "&
"dec edi "&
"xor ecx,-1 "&
"inc ecx "&
"ghl_@xloop: "&
"mov [edi + ecx],ah "&		-- (uchar *)(edi) = (ax >> 8)
"add eax,edx "&
"inc ecx "&
"jnz ghl_@xloop "&
"ghl_@skip: "&
"add ebx,4 "&
"pop ecx "&
"add ebp,[ghl_screenW] "&
"dec ecx "&
"jnz ghl_@yloop "&
"popa ret")
global constant ghl_numlines=ghl_code+get_param("ghl_numlines")
global constant ghl_y=ghl_code+get_param("ghl_y")
global constant ghl_scraddr=ghl_code+get_param("ghl_scraddr")
resolve_param("asm_xmax",asm_xmax)
resolve_param("asm_xmin",asm_xmin)
resolve_param("asm_cmax",asm_cmax)
resolve_param("asm_cmin",asm_cmin)
resolve_param("ghl_screenW",rScreenW)
resolve_param("ghl_maxW",rMaxW)


global constant ghl_mix_code=get_asm(
"pusha cld "&
"mov ecx,ghl_numlines "&
"mov ebp,ghl_y "&
"lea ebx,[ebp*4] "&
"mov eax,[ghl_screenW] "&
"mul ebp "&
"mov ebp,eax "&
"ghl_@yloop: "&
"push ecx "&
"mov edi,ghl_scraddr "&
"add edi,ebp "&
"mov eax,[asm_xmin + ebx] "&
"cmp eax,[ghl_maxW] "&
"jg ghl_@skip "&
"cmp eax,0 "&
"jnl ghl_@xmin_nl_0 "&
"mov eax,0 "&
"ghl_@xmin_nl_0: "&
"mov ecx,[asm_xmax + ebx] "&
"cmp ecx,0 "&
"jl ghl_@skip "&
"cmp ecx,[ghl_maxW] "&
"jng ghl_@xmax_ng_maxW "&
"mov ecx,[ghl_maxW] "&
"ghl_@xmax_ng_maxW: "&
"add edi,eax "&
"sub ecx,eax "&
"inc ecx "&
"mov eax,[asm_cmax + ebx] "&
"mov edx,[asm_cmin + ebx] "&
"sub eax,edx "&
"cwd "&
"idiv ecx "&
"mov edx,eax "&
"mov eax,[asm_cmin + ebx] "&
"lea edi,[edi+ecx] dec edi "&
"xor ecx,-1 "&
"inc ecx "&
"mov [ghl_mix_dummy],ebx "&
"and ebx,65535 "&
"ghl_@xloop: "&
"mov bl,[edi + ecx] "&
"mov bh,ah "&
"mov bl,[ghl_lup + ebx] "&
"mov [edi + ecx],bl "&
"add eax,edx "&
"inc ecx "&
"jnz ghl_@xloop "&
"mov ebx,[ghl_mix_dummy] "&
"ghl_@skip: "&
"add ebx,4 "&
"pop ecx "&
"add ebp,[ghl_screenW] "&
"dec ecx "&
"jz ghl_@return "&
"mov eax,ghl_mix_label_yloop "&
"jmp near eax "&
"ghl_@return: "&
"popa ret")
global constant ghl_mix_numlines=ghl_mix_code+get_param("ghl_numlines")
global constant ghl_mix_y=ghl_mix_code+get_param("ghl_y")
global constant ghl_mix_scraddr=ghl_mix_code+get_param("ghl_scraddr")
global constant ghl_mix_lup=ghl_mix_code+get_param("ghl_lup")
resolve_param("asm_xmax",asm_xmax)
resolve_param("asm_xmin",asm_xmin)
resolve_param("asm_cmax",asm_cmax)
resolve_param("asm_cmin",asm_cmin)
resolve_param("ghl_screenW",rScreenW)
resolve_param("ghl_maxW",rMaxW)
resolve_param("ghl_mix_dummy",rDummy)
resolve_param("ghl_mix_label_yloop",ghl_mix_code+get_label("ghl_@yloop"))


--STRUCT ghl16_data {
-- DWORD r,g,b
-- DWORD dr,dg,gb
--}
constant ghl16_data=allocate(24)

--*** Draw a number of shaded horizontal lines (for use with gouraud poly-drawers). ***--
global constant ghl16_code=get_asm(
"pusha cld "&
"mov ecx,ghl16_numlines "&
"mov ebp,ghl16_y "&
"lea ebx,[ebp*4] "&
"mov eax,[ghl16_screenW] "&
"mul ebp "&
"lea eax,[eax+eax] "&
"mov ebp,eax "&
"mov esi,63488 "&		--63488 = 11111000 00000000b
"ghl16_@yloop: "&
"push ecx "&
"mov edi,ghl16_scraddr "&
"add edi,ebp "&
"push ebp "&
"mov eax,[asm_xmin + ebx] "&
"cmp eax,[ghl16_maxW] "&
"jg ghl16_@bus_stop1 "&
"cmp eax,0 "&
"jnl ghl16_@xmin_nl_0 "&
"xor eax,eax "&
"ghl16_@xmin_nl_0: "&
"mov ecx,[asm_xmax + ebx] "&
"cmp ecx,0 "&
"jl ghl16_@bus_stop1 "&
"cmp ecx,[ghl16_maxW] "&
"jng ghl16_@xmax_ng_maxW "&
"mov ecx,[ghl16_maxW] "&
"ghl16_@xmax_ng_maxW: "&
"lea edi,[eax*2 + edi] "&
"sub ecx,eax "&
"inc ecx "&
"mov ebp,[asm_cmax + ebx] "&
"mov eax,ebp "&
"mov edx,[asm_cmin + ebx] "&
"and eax,31 "&			--31 = 00000000 00011111b
"and edx,31 "&
"sub eax,edx "&
"sal eax,11 shl edx,11 "&
"mov [ghl16_r],edx "&
"cwd "&
"idiv ecx "&
"mov [ghl16_dr],eax "&
"mov eax,ebp "&
"mov edx,[asm_cmin + ebx] "&
"and eax,2016 "&			--2016 = 00000111 11100000b
"and edx,2016 "&
"sub eax,edx "&
"sal eax,5 shl edx,5 "&
"mov [ghl16_g],edx "&
"cwd "&
"idiv ecx "&
"jmp ghl16_@do_stuff "&
"ghl16_@bus_stop1: "&
"jmp ghl16_@skip "&
"ghl16_@do_stuff: "&
"push ebx "&
"mov [ghl16_dg],eax "&
"mov eax,ebp "&
"mov edx,[asm_cmin + ebx] "&
"and eax,esi "&
"and edx,esi "&
"sub eax,edx "&
"mov [ghl16_b],edx "&
"cwd "&
"idiv ecx "&
"mov [ghl16_db],eax "&
"ghl16_@xloop: "&

"mov ebx,[ghl16_r] "&				--dx = RRRRRxxx xxxxxxxx
"mov eax,[ghl16_g] "&				--ax = GGGGGGxx xxxxxxxx
"and eax,64512 "&					--ax = GGGGGG00 00000000
"shr ebx,11 "&					--dx = 00000000 000RRRRR
"shr eax,5 "&					--ax = 00000GGG GGG00000
"or eax,ebx "&					--ax = 00000GGG GGGRRRRR
"mov ebx,[ghl16_b] "&				--dx = BBBBBxxx xxxxxxxx
"and ebx,63488 "&					--dx = BBBBB000 00000000
"or eax,ebx "&					--ax = BBBBBGGG GGGRRRRR

"stosw "&
"mov eax,[ghl16_dr] "&
"add [ghl16_r],eax "&
"mov eax,[ghl16_dg] "&
"add [ghl16_g],eax "&
"mov eax,[ghl16_db] "&
"add [ghl16_b],eax "&
"loop ghl16_@xloop "&
"pop ebx "&
"ghl16_@skip: "&
"add ebx,4 "&
"pop ebp "&
"pop ecx "&
"add ebp,[ghl16_screenW] "&
"add ebp,[ghl16_screenW] "&
"dec ecx "&
"jz ghl16_@return "&
"mov eax,ghl16_label_yloop "&
"jmp near eax "&
"ghl16_@return: "&
"popa ret")
global constant ghl16_numlines=ghl16_code+get_param("ghl16_numlines")
global constant ghl16_y=ghl16_code+get_param("ghl16_y")
global constant ghl16_scraddr=ghl16_code+get_param("ghl16_scraddr")
resolve_param("asm_xmax",asm_xmax)
resolve_param("asm_xmin",asm_xmin)
resolve_param("asm_cmax",asm_cmax)
resolve_param("asm_cmin",asm_cmin)
resolve_param("ghl16_screenW",rScreenW)
resolve_param("ghl16_maxW",rMaxW)
resolve_param("ghl16_r",ghl16_data)
resolve_param("ghl16_g",(ghl16_data+4))
resolve_param("ghl16_b",(ghl16_data+8))
resolve_param("ghl16_dr",(ghl16_data+12))
resolve_param("ghl16_dg",(ghl16_data+16))
resolve_param("ghl16_db",(ghl16_data+20))
resolve_param("ghl16_label_yloop",ghl16_code+get_label("ghl16_@yloop"))


--*** Draw a number of shaded horizontal lines (for use with gouraud poly-drawers). ***--
global constant ghl15_code=get_asm(
"pusha cld "&
"mov ecx,ghl15_numlines "&
"mov ebp,ghl15_y "&
"lea ebx,[ebp*4] "&
"mov eax,[ghl15_screenW] "&
"mul ebp "&
"lea eax,[eax+eax] "&
"mov ebp,eax "&
"mov esi,31744 "&		--31744 = 01111100 00000000b
"ghl15_@yloop: "&
"push ecx "&
"mov edi,ghl15_scraddr "&
"add edi,ebp "&
"push ebp "&
"mov eax,[asm_xmin + ebx] "&
"cmp eax,[ghl15_maxW] "&
"jng ghl15_@proceed_1 "&
"mov eax,ghl15_label_skip "&
"jmp near eax "&
"ghl15_@proceed_1: "&
"cmp eax,0 "&
"jnl ghl15_@xmin_nl_0 "&
"xor eax,eax "&
"ghl15_@xmin_nl_0: "&
"mov ecx,[asm_xmax + ebx] "&
"cmp ecx,0 "&
"jnl ghl15_@proceed_2 "&
"mov eax,ghl15_label_skip "&
"jmp near eax "&
"ghl15_@proceed_2: "&
"cmp ecx,[ghl15_maxW] "&
"jng ghl15_@xmax_ng_maxW "&
"mov ecx,[ghl15_maxW] "&
"ghl15_@xmax_ng_maxW: "&
"lea edi,[eax*2 + edi] "&
"sub ecx,eax "&
"inc ecx "&
"mov ebp,[asm_cmax + ebx] "&
"mov eax,ebp "&
"mov edx,[asm_cmin + ebx] "&
"and eax,31 "&			--31 = 00000000 00011111b
"and edx,31 "&
"sub eax,edx "&
"sal eax,10 shl edx,10 "&
"mov [ghl15_r],edx "&
"cwd "&
"idiv ecx "&
"mov [ghl15_dr],eax "&
"mov eax,ebp "&
"mov edx,[asm_cmin + ebx] "&
"and eax,992 "&			--992 = 00000011 11100000b
"and edx,992 "&
"sub eax,edx "&
"sal eax,5 shl edx,5 "&
"mov [ghl15_g],edx "&
"cwd "&
"idiv ecx "&
"push ebx "&
"mov [ghl15_dg],eax "&
"mov eax,ebp "&
"mov edx,[asm_cmin + ebx] "&
"and eax,esi "&
"and edx,esi "&
"sub eax,edx "&
"mov [ghl15_b],edx "&
"cwd "&
"idiv ecx "&
"mov [ghl15_db],eax "&
"lea edi,[edi + ecx*2] dec edi dec edi "&
"xor ecx,-1 "&
"inc ecx "&
"ghl15_@xloop: "&
--*** stupid rbg-to-color convertion coming up.. ***--

"mov ebx,[ghl15_r] "&		--bx = 0RRRRRxx xxxxxxxx	
"mov eax,[ghl15_g] "&		--ax = 0GGGGGxx xxxxxxxx
"and eax,31744 "&			--ax = 0GGGGG00 00000000
"shr ebx,10 "&			--bx = 00000000 000RRRRR
"shr eax,5 "&			--ax = 000000GG GGG00000
"or eax,ebx "&			--ax = 000000GG GGGRRRRR
"mov ebx,[ghl15_b] "&		--bx = 0BBBBBxx xxxxxxxx
"and ebx,31744 "&			--bx = 0BBBBB00 00000000
"or eax,ebx "&			--ax = 0BBBBBGG GGGRRRRR

"mov [edi + ecx*2],ax "&
"mov eax,[ghl15_dr] "&
"add [ghl15_r],eax "&
"mov eax,[ghl15_dg] "&
"add [ghl15_g],eax "&
"mov eax,[ghl15_db] "&
"add [ghl15_b],eax "&
"inc ecx "&
"jnz ghl15_@xloop "&
"pop ebx "&
"ghl15_@skip: "&
"add ebx,4 "&
"pop ebp "&
"pop ecx "&
"add ebp,[ghl15_screenW] "&
"add ebp,[ghl15_screenW] "&
"dec ecx "&
"jz ghl15_@return "&
"mov eax ghl15_label_yloop "&
"jmp near eax "&
"ghl15_@return: "&
"popa ret")
global constant ghl15_numlines=ghl15_code+get_param("ghl15_numlines")
global constant ghl15_y=ghl15_code+get_param("ghl15_y")
global constant ghl15_scraddr=ghl15_code+get_param("ghl15_scraddr")
resolve_param("asm_xmax",asm_xmax)
resolve_param("asm_xmin",asm_xmin)
resolve_param("asm_cmax",asm_cmax)
resolve_param("asm_cmin",asm_cmin)
resolve_param("ghl15_screenW",rScreenW)
resolve_param("ghl15_maxW",rMaxW)
resolve_param("ghl15_r",ghl16_data)
resolve_param("ghl15_g",(ghl16_data+4))
resolve_param("ghl15_b",(ghl16_data+8))
resolve_param("ghl15_dr",(ghl16_data+12))
resolve_param("ghl15_dg",(ghl16_data+16))
resolve_param("ghl15_db",(ghl16_data+20))
resolve_param("ghl15_label_yloop",ghl15_code+get_label("ghl15_@yloop"))
resolve_param("ghl15_label_skip",ghl15_code+get_label("ghl15_@skip"))


--*** Draw a number of shaded horizontal lines (for use with gouraud poly-drawers). ***--
global constant ghl24_code=get_asm(
"pusha cld "&
"mov ecx,ghl24_numlines "&
"mov ebp,ghl24_y "&
"lea ebx,[ebp*4] "&
"mov eax,[ghl24_screenW] "&
"mul ebp "&
"lea eax,[eax*2 + eax] "&
"mov ebp,eax "&
"ghl24_@yloop: "&
"push ecx "&
"mov edi,ghl24_scraddr "&
"add edi,ebp "&
"push ebp "&
"mov eax,[asm_xmin + ebx] "&
"cmp eax,[ghl24_maxW] "&
"jng ghl24_@proceed_1 "&
"mov eax,ghl24_label_skip "&
"jmp near eax "&
"ghl24_@proceed_1: "&
"cmp eax,0 "&
"jnl ghl24_@xmin_nl_0 "&
"xor eax,eax "&
"ghl24_@xmin_nl_0: "&
"mov ecx,[asm_xmax + ebx] "&
"cmp ecx,0 "&
"jnl ghl24_@proceed_2 "&
"mov eax,ghl24_label_skip "&
"jmp near eax "&
"ghl24_@proceed_2: "&
"cmp ecx,[ghl15_maxW] "&
"jng ghl24_@xmax_ng_maxW "&
"mov ecx,[ghl24_maxW] "&
"ghl24_@xmax_ng_maxW: "&
"lea edi,[eax*2 + edi] "&
"add edi,eax "&
"sub ecx,eax "&
"inc ecx "&
"mov ebp,[asm_cmax + ebx] "&
"mov eax,ebp "&
"mov edx,[asm_cmin + ebx] "&
"and eax,255 "&			--255 = 00000000 00000000 11111111
"and edx,255 "&
"sub eax,edx "&
"sal eax,8 shl edx,8 "&		--interpolate colors as 8:8 fixed point values
"mov [ghl24_r],edx "&
"cwd "&
"idiv ecx "&
"mov [ghl24_dr],eax "&
"mov eax,ebp "&
"mov edx,[asm_cmin + ebx] "&
"and eax,65280 "&			--65280 = 00000000 11111111 00000000
"and edx,65280 "&
"sub eax,edx "&
"mov [ghl24_g],edx "&
"cwd "&
"idiv ecx "&
"push ebx "&
"mov [ghl24_dg],eax "&
"mov eax,ebp "&
"mov edx,[asm_cmin + ebx] "&
"and eax,16711680 "&		--16711680 = 11111111 00000000 00000000
"and edx,16711680 "&
"sub eax,edx "&
"sar eax,8 shr edx,8 "&
"mov [ghl24_b],edx "&
"cwd "&
"idiv ecx "&
"mov [ghl24_db],eax "&
"lea edi,[edi + ecx*2] "&
"add edi,ecx "&
"sub edi,3 "&
"xor ecx,-1 "&
"inc ecx "&
"ghl24_@xloop: "&
"mov eax,[ghl24_g] "&			--eax = 00000000 00000000 GGGGGGGG xxxxxxxx
"mov al,[ghl24_b + 1] "&
--"mov edx,[ghl24_b] "&			--edx = 00000000 00000000 BBBBBBBB xxxxxxxx
--"mov al,dh "&				--eax = 00000000 00000000 GGGGGGGG BBBBBBBB
"mov edx,[ghl24_r] "&			--edx = 00000000 00000000 RRRRRRRR xxxxxxxx
"mov esi,edi "&
"add edi,ecx "&
"mov [edi + ecx*2],ax "&		-- *(dest) = (word)(GGGGGGGG BBBBBBBB)
"inc edi inc edi "&
"mov [edi + ecx*2],dh "&		-- *(dest+2) = (byte)(RRRRRRRR)
"mov edi,esi "&
"mov eax,[ghl24_dr] "&
"add [ghl24_r],eax "&
"mov eax,[ghl24_dg] "&
"add [ghl24_g],eax "&
"mov eax,[ghl24_db] "&
"add [ghl24_b],eax "&
"inc ecx "&
"jnz ghl24_@xloop "&
"pop ebx "&
"ghl24_@skip: "&
"add ebx,4 "&
"pop ebp "&
"pop ecx "&
"mov eax,[ghl24_screenW] "&
"lea eax,[eax*2 + eax] "&
"add ebp,eax "&
"dec ecx "&
"jz ghl24_@return "&
"mov eax ghl24_label_yloop "&
"jmp near eax "&
"ghl24_@return: "&
"popa ret")
global constant ghl24_numlines=ghl24_code+get_param("ghl24_numlines")
global constant ghl24_y=ghl24_code+get_param("ghl24_y")
global constant ghl24_scraddr=ghl24_code+get_param("ghl24_scraddr")
resolve_param("asm_xmax",asm_xmax)
resolve_param("asm_xmin",asm_xmin)
resolve_param("asm_cmax",asm_cmax)
resolve_param("asm_cmin",asm_cmin)
resolve_param("ghl24_screenW",rScreenW)
resolve_param("ghl24_maxW",rMaxW)
resolve_param("ghl24_r",ghl16_data)
resolve_param("ghl24_g",(ghl16_data+4))
resolve_param("ghl24_b",(ghl16_data+8))
resolve_param("ghl24_dr",(ghl16_data+12))
resolve_param("ghl24_dg",(ghl16_data+16))
resolve_param("ghl24_db",(ghl16_data+20))
resolve_param("ghl24_label_yloop",ghl24_code+get_label("ghl24_@yloop"))
resolve_param("ghl24_label_skip",ghl24_code+get_label("ghl24_@skip"))


--** data for texture-filler **--
global constant thl_deltaX=allocate(4), thl_deltaY=allocate(4)

--*** Draw a number of textured horizontal lines (for use with texture poly-drawers). ***--
global constant thl_code=get_asm(
"pusha cld "&
"mov ecx,thl_numlines "&
"mov edx,thl_y "&
"lea ebx,[edx*4] "&
"mov eax,[thl_screenW] "&
"mul edx "&
"mov edx,eax "&
"thl_@yloop: "&
"push ecx "&
"mov edi,thl_scraddr "&
"mov eax,[asm_xmin + ebx] "&
"add edi,edx "&
"cmp eax,[thl_maxW] "&
"jg thl_@bus_stop1 "&
"cmp eax,0 "&
"jnl thl_@xmin_nl_0 "&
"mov eax,0 "&
"thl_@xmin_nl_0: "&
"mov ecx,[asm_xmax + ebx] "&
"cmp ecx,0 "&
"jl thl_@bus_stop1 "&
"cmp ecx,[thl_maxW] "&
"jng thl_@xmax_ng_maxW "&
"mov ecx,[thl_maxW] "&
"thl_@xmax_ng_maxW: "&
"add edi,eax "&
"sub ecx,eax "&
"push edx "&
"inc ecx "&
"mov eax,[asm_umax + ebx] "&
"sub eax,[asm_umin + ebx] "&
--"sub eax,edx "&
"cwd "&
"idiv ecx "&
"mov [thl_deltax],eax "&
"jmp thl_@do_stuff "&
"thl_@bus_stop1: "&
"jmp thl_@skip "&
"thl_@do_stuff: "&
"mov eax,[asm_vmax + ebx] "&
"sub eax,[asm_vmin + ebx] "&
--"sub eax,edx "&
"cwd "&
"idiv ecx "&
"mov ebp,eax "&
"mov eax,[asm_umin + ebx] "&
"mov edx,[asm_vmin + ebx] "&
"push ebx "&
"mov esi,thl_texture "&
"mov ebx,ebp "&
"lea edi,[edi + ecx] dec edi "&
"xor ecx,-1 "&
"inc ecx "&
"thl_@xloop: "&
"mov ebp,edx "&
"mov dl,ah "&
"mov dl,[esi + edx] "&
"mov [edi + ecx],dl "&
"mov edx,ebp "&
"add edx,ebx "&
"add eax,[thl_deltax] "&
"inc ecx "&
"jnz thl_@xloop "&
"pop ebx "&
"pop edx "&
"thl_@skip: "&
"add ebx,4 "&
"pop ecx "&
"add edx,[thl_screenW] "&
"dec ecx "&
"jz thl_@return "&
"mov eax,thl_label_yloop "&
"jmp near eax "&
"thl_@return: "&
"popa ret")
global constant thl_numlines=thl_code+get_param("thl_numlines")
global constant thl_y=thl_code+get_param("thl_y")
global constant thl_scraddr=thl_code+get_param("thl_scraddr")
global constant thl_texture=thl_code+get_param("thl_texture")
resolve_param("asm_xmax",asm_xmax)
resolve_param("asm_xmin",asm_xmin)
resolve_param("asm_umax",asm_umax)
resolve_param("asm_umin",asm_umin)
resolve_param("asm_vmax",asm_vmax)
resolve_param("asm_vmin",asm_vmin)
resolve_param("thl_deltax",thl_deltaX)
--resolve_param("thl_deltay",thl_deltaY)
resolve_param("thl_screenW",rScreenW)
resolve_param("thl_maxW",rMaxW)
resolve_param("thl_label_yloop",thl_code+get_label("thl_@yloop"))
--resolve_param("thl_label_skip",thl_code+get_label("thl_@skip"))


global constant thl_clip_code=get_asm(
"pusha cld "&
"mov ecx,thl_numlines "&
"mov edx,thl_y "&
"lea ebx,[edx*4] "&
"mov eax,[thl_screenW] "&
"mul edx "&
"mov edx,eax "&
"thl_@yloop: "&
"push ecx "&
"mov eax,0 "&
"mov [thl_clip],eax "&
"mov [thl_clip_4],eax "&
"mov edi,thl_scraddr "&
"mov eax,[asm_xmin + ebx] "&
"add edi,edx "&
"cmp eax,[thl_maxW] "&
"jng thl_@procceed_1 "&
"mov eax,thl_label_skip "&
"jmp near eax "&
"thl_@procceed_1: "&

"cmp eax,0 "&
"jnl thl_@xmin_nl_0 "&
"neg eax "&
"mov [thl_clip],eax "&
"mov eax,0 "&
"thl_@xmin_nl_0: "&
"mov ecx,[asm_xmax + ebx] "&
"cmp ecx,0 "&
"jnl thl_@procceed_2 "&
"mov eax,thl_label_skip "&
"jmp near eax "&
"thl_@procceed_2: "&

"cmp ecx,[thl_maxW] "&
"jng thl_@xmax_ng_maxW "&
"sub ecx,[thl_maxW] "&
"mov [thl_clip_4],ecx "&
"mov ecx,[thl_maxW] "&
"thl_@xmax_ng_maxW: "&
"add edi,eax "&
"sub ecx,eax "&
"push edx "&
"inc ecx "&
"mov eax,[asm_umax + ebx] "&
"sub eax,[asm_umin + ebx] "&
--"sub eax,edx "&
"cwd "&
"idiv ecx "&
"mov [thl_deltax],eax "&
"mov eax,[asm_vmax + ebx] "&
"sub eax,[asm_vmin + ebx] "&
--"sub eax,edx "&
"cwd "&
"idiv ecx "&

"mov [thl_deltay],eax "&
"mov ebp,0 "&
"mov esi,[thl_clip] "&
"cmp esi,0 "&
"je thl_@no_xmin_clip "&
"mov eax,[thl_deltax] "&
"imul esi "&
"add [asm_umin + ebx],eax "&
"mov eax,[thl_deltay] "&
"imul esi "&
"add [asm_vmin + ebx],eax "&
"inc ebp "&
"thl_@no_xmin_clip: "&
"mov esi,[thl_clip_4] "&
"cmp esi,0 "&
"je thl_@no_xmax_clip "&
"mov eax,[thl_deltax] "&
"imul esi "&
"sub [asm_umax + ebx],eax "&
"mov eax,[thl_deltay] "&
"imul esi "&
"sub [asm_vmax + ebx],eax "&
"inc ebp "&
"thl_@no_xmax_clip: "&
"cmp ebp,0 "&
"je thl_@no_clip_correction "&
"mov eax,[asm_umax + ebx] "&
"sub eax,[asm_umin + ebx] "&
--"sub eax,edx "&
"cwd "&
"idiv ecx "&
"mov [thl_deltax],eax "&
"mov eax,[asm_vmax + ebx] "&
"sub eax,[asm_vmin + ebx] "&
--"sub eax,edx "&
"cwd "&
"idiv ecx "&
"mov [thl_deltay],eax "&
"thl_@no_clip_correction: "&

"mov ebp,[thl_deltay] "&
"mov eax,[asm_umin + ebx] "&
"mov edx,[asm_vmin + ebx] "&
"push ebx "&
"mov esi,thl_texture "&
"mov ebx,ebp "&
"lea edi,[edi + ecx] dec edi "&
"xor ecx,-1 "&
"inc ecx "&
"thl_@xloop: "&
"mov ebp,edx "&
"mov dl,ah "&
"mov dl,[esi + edx] "&
"mov [edi + ecx],dl "&
"mov edx,ebp "&
"add edx,ebx "&
"add eax,[thl_deltax] "&
"inc ecx "&
"jnz thl_@xloop "&
"pop ebx "&
"pop edx "&
"thl_@skip: "&
"add ebx,4 "&
"pop ecx "&
"add edx,[thl_screenW] "&
"dec ecx "&
"jz thl_@return "&
"mov eax,thl_label_yloop "&
"jmp near eax "&
"thl_@return: "&
"popa ret")
global constant thl_clip_numlines=thl_clip_code+get_param("thl_numlines")
global constant thl_clip_y=thl_clip_code+get_param("thl_y")
global constant thl_clip_scraddr=thl_clip_code+get_param("thl_scraddr")
global constant thl_clip_texture=thl_clip_code+get_param("thl_texture")
resolve_param("asm_xmax",asm_xmax)
resolve_param("asm_xmin",asm_xmin)
resolve_param("asm_umax",asm_umax)
resolve_param("asm_umin",asm_umin)
resolve_param("asm_vmax",asm_vmax)
resolve_param("asm_vmin",asm_vmin)
resolve_param("thl_deltax",thl_deltaX)
resolve_param("thl_deltay",thl_deltaY)
resolve_param("thl_screenW",rScreenW)
resolve_param("thl_maxW",rMaxW)
resolve_param("thl_clip",rClip)
resolve_param("thl_clip_4",rClip+4)
resolve_param("thl_label_yloop",thl_clip_code+get_label("thl_@yloop"))
resolve_param("thl_label_skip",thl_clip_code+get_label("thl_@skip"))




--*** Draw a number of textured horizontal lines (for use with texture poly-drawers). ***--
global constant thl_mix_code=get_asm(
"pusha cld "&
"mov ecx,thl_numlines "&
"mov edx,thl_y "&
"lea ebx,[edx*4] "&
"mov eax,[thl_screenW] "&
"mul edx "&
"mov edx,eax "&
"thl_@yloop: "&
"push ecx "&
"mov edi,thl_scraddr "&
"mov eax,[asm_xmin + ebx] "&
"add edi,edx "&
"cmp eax,[thl_maxW] "&
"jg thl_@bus_stop1 "&
"cmp eax,0 "&
"jnl thl_@xmin_nl_0 "&
"mov eax,0 "&
"thl_@xmin_nl_0: "&
"mov ecx,[asm_xmax + ebx] "&
"cmp ecx,0 "&
"jl thl_@bus_stop1 "&
"cmp ecx,[thl_maxW] "&
"jng thl_@xmax_ng_maxW "&
"mov ecx,[thl_maxW] "&
"thl_@xmax_ng_maxW: "&
"add edi,eax "&
"sub ecx,eax "&
"push edx "&
"inc ecx "&
"mov eax,[asm_umax + ebx] "&
"mov edx,[asm_umin + ebx] "&
"sub eax,edx "&
"cwd "&
"idiv ecx "&
"mov [thl_deltax],eax "&
"jmp thl_@do_stuff "&
"thl_@bus_stop1: "&
"jmp thl_@skip "&
"thl_@do_stuff: "&
"mov eax,[asm_vmax + ebx] "&
"mov edx,[asm_vmin + ebx] "&
"sub eax,edx "&
"cwd "&
"idiv ecx "&
"mov ebp,eax "&
"mov eax,[asm_umin + ebx] "&
"mov edx,[asm_vmin + ebx] "&
"push ebx "&
"mov esi,thl_texture "&
"mov ebx,ebp "&
"lea edi,[edi+ecx] dec edi "&
"xor ecx,-1 "&
"inc ecx "&
"thl_@xloop: "&
"mov ebp,edx "&
"mov [thl_dummy],eax "&
"mov dl,ah "&
"mov ah,[esi + edx] "&
"mov al,[edi + ecx] "&
"and eax,65535 "&
"mov dl,[thl_lup + eax] "&
"mov [edi + ecx],dl "&
"mov edx,ebp "&
"mov eax,[thl_dummy] "&
"add edx,ebx "&
"add eax,[thl_deltax] "&
"inc ecx "&
"jnz thl_@xloop "&
"pop ebx "&
"pop edx "&
"thl_@skip: "&
"add ebx,4 "&
"pop ecx "&
"add edx,[thl_screenW] "&
"dec ecx "&
"jz thl_@return "&
"mov eax,thl_label_yloop "&
"jmp near eax "&
"thl_@return: "&
"popa ret")
global constant thl_mix_numlines=thl_mix_code+get_param("thl_numlines")
global constant thl_mix_y=thl_mix_code+get_param("thl_y")
global constant thl_mix_scraddr=thl_mix_code+get_param("thl_scraddr")
global constant thl_mix_texture=thl_mix_code+get_param("thl_texture")
global constant thl_mix_lup=thl_mix_code+get_param("thl_lup")
resolve_param("asm_xmax",asm_xmax)
resolve_param("asm_xmin",asm_xmin)
resolve_param("asm_umax",asm_umax)
resolve_param("asm_umin",asm_umin)
resolve_param("asm_vmax",asm_vmax)
resolve_param("asm_vmin",asm_vmin)
resolve_param("thl_deltax",thl_deltaX)
resolve_param("thl_screenW",rScreenW)
resolve_param("thl_maxW",rMaxW)
resolve_param("thl_dummy",rDummy)
resolve_param("thl_label_yloop",thl_mix_code+get_label("thl_@yloop"))



global constant thl_tile_code=get_asm(
"pusha cld "&
"mov ecx,thl_numlines "&
"mov edx,thl_y "&
"lea ebx,[edx*4] "&
"mov eax,[thl_screenW] "&
"mul edx "&
"mov edx,eax "&
"thl_@yloop: "&
"push ecx "&
"mov edi,thl_scraddr "&
"mov eax,[asm_xmin + ebx] "&
"add edi,edx "&
"cmp eax,[thl_maxW] "&
"jng thl_@proceed_1 "&
"mov eax,thl_label_skip "&
"jmp near eax "&
"thl_@proceed_1: "&
"cmp eax,0 "&
"jnl thl_@xmin_nl_0 "&
"mov eax,0 "&
"thl_@xmin_nl_0: "&
"mov ecx,[asm_xmax + ebx] "&
"cmp ecx,0 "&
"jnl thl_@proceed_2 "&
"mov eax,thl_label_skip "&
"jmp near eax "&
"thl_@proceed_2: "&
"cmp ecx,[thl_maxW] "&
"jng thl_@xmax_ng_maxW "&
"mov ecx,[thl_maxW] "&
"thl_@xmax_ng_maxW: "&
"add edi,eax "&
"sub ecx,eax "&
"push edx "&
"inc ecx "&
"mov eax,[asm_umax + ebx] "&
"sub eax,[asm_umin + ebx] "&
--"sub eax,edx "&
"cwd "&
"idiv ecx "&
"mov ebp,eax "&
"mov edx,eax "&
"shl eax,7 shl eax,1 "&
"and eax,4160749568 "&
"shr ebp,1 "&
"and ebp,32767 "&
"and edx,458752 "&
"add eax,ebp "&
"add eax,edx "&
"or eax,133726208 "&
"mov [tiledudx],eax "&
"mov eax,[asm_vmax + ebx] "&
"sub eax,[asm_vmin + ebx] "&
--"sub eax,edx "&
"cwd "&
"idiv ecx "&
"mov ebp,eax "&
"shl eax,2 shl eax,1 "&
"and eax,133693440 "&
"shr ebp,1 "&
"and ebp,32767 "&
"add eax,ebp "&
"or eax,4161241088 "&
"mov [tiledvdx],eax "&
"mov ebp,[asm_umin + ebx] "&
"mov eax,ebp "&
"mov edx,eax "&
"shl ebp,8 "&
"and ebp,4160749568 "&
"shr eax,1 "&
"and eax,32767 "&
"and edx,458752 "&
"add ebp,eax "&
"add ebp,edx "&
"mov edx,[asm_vmin + ebx] "&
"mov eax,edx "&
"shl edx,2 shl edx,1 "&
"and edx,133693440 "&
"shr eax,1 "&
"and eax,32767 "&
"add edx,eax "&
"push ebx "&
"mov ebx,edx "&
"lea edi,[edi+ecx] "&
"dec edi "&
"xor ecx,-1 "&
"inc ecx "&
"lea eax,[ebp+ebx] "&
"thl_@xloop: "&
"add ebp,[tiledudx] "&
"add ebx,[tiledvdx] "&
"shr eax,15 shr eax,1 "&
"and ebp,4161241087 "&
"and ebx,133726207 "&
"mov dl,[thl_texture + eax] "&
"mov [edi + ecx],dl "&
"lea eax,[ebp + ebx] "&
"inc ecx "&
"jnz thl_@xloop "&
"pop ebx "&
"pop edx "&
--"mov ebx,[esp] "&
--"mov edx,[esp + 4] "&
--"add esp,8 "&
"thl_@skip: "&
"add ebx,4 "&
"pop ecx "&
"add edx,[thl_screenW] "&
"dec ecx "&
"jz thl_@return "&
"mov eax,thl_label_yloop "&
"jmp near eax "&
"thl_@return: "&
"popa ret")
global constant thl_tile_numlines=thl_tile_code+get_param("thl_numlines")
global constant thl_tile_y=thl_tile_code+get_param("thl_y")
global constant thl_tile_scraddr=thl_tile_code+get_param("thl_scraddr")
global constant thl_tile_texture=thl_tile_code+get_param("thl_texture")
resolve_param("asm_xmax",asm_xmax)
resolve_param("asm_xmin",asm_xmin)
resolve_param("asm_umax",asm_umax)
resolve_param("asm_umin",asm_umin)
resolve_param("asm_vmax",asm_vmax)
resolve_param("asm_vmin",asm_vmin)
resolve_param("tiledudx",thl_deltaX)
resolve_param("tiledvdx",thl_deltaY)
resolve_param("thl_screenW",rScreenW)
resolve_param("thl_maxW",rMaxW)
resolve_param("thl_label_yloop",thl_tile_code+get_label("thl_@yloop"))
resolve_param("thl_label_skip",thl_tile_code+get_label("thl_@skip"))




--*** Draw a number of textured horizontal lines (for use with texture poly-drawers). ***--
global constant thl1516_code=get_asm(
"pusha cld "&
"mov ecx,thl16_numlines "&
"mov edx,thl16_y "&
"lea ebx,[edx*4] "&
"mov eax,[thl16_screenW] "&
"mul edx "&
"lea eax,[eax+eax] "&
"mov edx,eax "&
"thl16_@yloop: "&
"push ecx "&
"mov edi,thl16_scraddr "&
"add edi,edx "&
"mov eax,[asm_xmin + ebx] "&
"cmp eax,[thl16_maxW] "&
"jg thl16_@bus_stop1 "&
"cmp eax,0 "&
"jnl thl16_@xmin_nl_0 "&
"mov eax,0 "&
"thl16_@xmin_nl_0: "&
"mov ecx,[asm_xmax + ebx] "&
"cmp ecx,0 "&
"jl thl16_@bus_stop1 "&
"cmp ecx,[thl16_maxW] "&
"jng thl16_@xmax_ng_maxW "&
"mov ecx,[thl16_maxW] "&
"thl16_@xmax_ng_maxW: "&
"add edi,eax "&
"add edi,eax "&
"sub ecx,eax "&
"push edx "&
"inc ecx "&
"mov eax,[asm_umax + ebx] "&
"mov edx,[asm_umin + ebx] "&
"sub eax,edx "&
"cwd "&
"idiv ecx "&
"mov [thl16_deltax],eax "&
"jmp thl16_@do_stuff "&
"thl16_@bus_stop1: "&
"jmp thl16_@skip "&
"thl16_@do_stuff: "&
"mov eax,[asm_vmax + ebx] "&
"mov edx,[asm_vmin + ebx] "&
"sub eax,edx "&
"cwd "&
"idiv ecx "&
"mov ebp,eax "&
"mov eax,[asm_umin + ebx] "&
"mov edx,[asm_vmin + ebx] "&
"push ebx "&
"mov esi,thl16_texture "&
"mov ebx,ebp "&
"lea edi,[edi + ecx*2] "&
"dec edi "&
"dec edi "&
"xor ecx,-1 "&
"inc ecx "&
"thl16_@xloop: "&
"mov ebp,edx "&
"mov dl,ah "&
"mov dx,word ptr [esi + edx*2] "&
"mov [edi + ecx*2],dx "&
"mov edx,ebp "&
"add edx,ebx "&
"add eax,[thl16_deltax] "&
"inc ecx "&
"jnz thl16_@xloop "&
"pop ebx "&
"pop edx "&
"thl16_@skip: "&
"add ebx,4 "&
"pop ecx "&
"add edx,[thl16_screenW] "&
"add edx,[thl16_screenW] "&
"dec cx "&
"jz thl16_@return "&
"mov eax,thl16_label_yloop "&
"jmp near eax "&
"thl16_@return: "&
"popa ret")
global constant thl1516_numlines=thl1516_code+get_param("thl16_numlines")
global constant thl1516_y=thl1516_code+get_param("thl16_y")
global constant thl1516_scraddr=thl1516_code+get_param("thl16_scraddr")
global constant thl1516_texture=thl1516_code+get_param("thl16_texture")
resolve_param("asm_xmax",asm_xmax)
resolve_param("asm_xmin",asm_xmin)
resolve_param("asm_umax",asm_umax)
resolve_param("asm_umin",asm_umin)
resolve_param("asm_vmax",asm_vmax)
resolve_param("asm_vmin",asm_vmin)
resolve_param("thl16_deltax",thl_deltaX)
resolve_param("thl16_screenW",rScreenW)
resolve_param("thl16_maxW",rMaxW)
resolve_param("thl16_label_yloop",thl1516_code+get_label("thl16_@yloop"))


--*** Draw a number of textured horizontal lines (for use with texture poly-drawers). ***--
global constant thl16_mix_code=get_asm(
"pusha cld "&
"mov ecx,thl16_numlines "&
"mov edx,thl16_y "&
"lea ebx,[edx*4] "&
"mov eax,[thl16_screenW] "&
"mul edx "&
"lea eax,[eax+eax] "&
"mov edx,eax "&
"thl16_@yloop: "&
"push ecx "&
"mov edi,thl16_scraddr "&
"add edi,edx "&
"mov eax,[asm_xmin + ebx] "&
"cmp eax,[thl16_maxW] "&
"jg thl16_@bus_stop1 "&
"cmp eax,0 "&
"jnl thl16_@xmin_nl_0 "&
"mov eax,0 "&
"thl16_@xmin_nl_0: "&
"mov ecx,[asm_xmax + ebx] "&
"cmp ecx,0 "&
"jl thl16_@bus_stop1 "&
"cmp ecx,[thl16_maxW] "&
"jng thl16_@xmax_ng_maxW "&
"mov ecx,[thl16_maxW] "&
"thl16_@xmax_ng_maxW: "&
"add edi,eax "&
"add edi,eax "&
"sub ecx,eax "&
"push edx "&
"inc ecx "&
"mov eax,[asm_umax + ebx] "&
"mov edx,[asm_umin + ebx] "&
"sub eax,edx "&
"cwd "&
"idiv ecx "&
"mov [thl16_deltax],eax "&
"jmp thl16_@do_stuff "&
"thl16_@bus_stop1: "&
"jmp thl16_@skip "&
"thl16_@do_stuff: "&
"mov eax,[asm_vmax + ebx] "&
"mov edx,[asm_vmin + ebx] "&
"sub eax,edx "&
"cwd "&
"idiv ecx "&
"mov ebp,eax "&
"mov eax,[asm_umin + ebx] "&
"mov edx,[asm_vmin + ebx] "&
"push ebx "&
"mov esi,thl16_texture "&
"mov ebx,ebp "&
"lea edi,[edi + ecx*2] "&
"xor ecx,-1 "&
"inc ecx "&
"thl16_@xloop: "&
"mov ebp,edx "&
"mov [thl16_dummy],eax "&
"mov dl,ah "&
"mov dx,word ptr [esi + edx*2] "&
"mov ax,word ptr [edi +ecx*2] "&
"shr eax,1 shr edx,1 "&
"and eax,31727 and edx,31727 add dx,ax "& 
"mov [edi + ecx*2],dx "&
"mov edx,ebp "&
"mov eax,[thl16_dummy] "&
"add edx,ebx "&
"add eax,[thl16_deltax] "&
"inc ecx "&
"jnz thl16_@xloop "&
"pop ebx "&
"pop edx "&
"thl16_@skip: "&
"add ebx,4 "&
"pop ecx "&
"add edx,[thl16_screenW] "&
"add edx,[thl16_screenW] "&
"dec cx "&
"jz thl16_@return "&
"mov eax,thl16_label_yloop "&
"jmp near eax "&
"thl16_@return: "&
"popa ret")
global constant thl16_mix_numlines=thl16_mix_code+get_param("thl16_numlines")
global constant thl16_mix_y=thl16_mix_code+get_param("thl16_y")
global constant thl16_mix_scraddr=thl16_mix_code+get_param("thl16_scraddr")
global constant thl16_mix_texture=thl16_mix_code+get_param("thl16_texture")
resolve_param("asm_xmax",asm_xmax)
resolve_param("asm_xmin",asm_xmin)
resolve_param("asm_umax",asm_umax)
resolve_param("asm_umin",asm_umin)
resolve_param("asm_vmax",asm_vmax)
resolve_param("asm_vmin",asm_vmin)
resolve_param("thl16_deltax",thl_deltaX)
resolve_param("thl16_screenW",rScreenW)
resolve_param("thl16_maxW",rMaxW)
resolve_param("thl16_dummy",rDummy)
resolve_param("thl16_label_yloop",thl16_mix_code+get_label("thl16_@yloop"))


--*** Draw a number of textured horizontal lines (for use with texture poly-drawers). ***--
global constant thl15_mix_code=get_asm(
"pusha cld "&
"mov ecx,thl15_numlines "&
"mov edx,thl15_y "&
"lea ebx,[edx*4] "&
"mov eax,[thl15_screenW] "&
"mul edx "&
"lea eax,[eax+eax] "&
"mov edx,eax "&
"thl15_@yloop: "&
"push ecx "&
"mov edi,thl15_scraddr "&
"add edi,edx "&
"mov eax,[asm_xmin + ebx] "&
"cmp eax,[thl15_maxW] "&
"jg thl15_@bus_stop1 "&
"cmp eax,0 "&
"jnl thl15_@xmin_nl_0 "&
"mov eax,0 "&
"thl15_@xmin_nl_0: "&
"mov ecx,[asm_xmax + ebx] "&
"cmp ecx,0 "&
"jl thl15_@bus_stop1 "&
"cmp ecx,[thl15_maxW] "&
"jng thl15_@xmax_ng_maxW "&
"mov ecx,[thl15_maxW] "&
"thl15_@xmax_ng_maxW: "&
"add edi,eax "&
"add edi,eax "&
"sub ecx,eax "&
"push edx "&
"inc ecx "&
"mov eax,[asm_umax + ebx] "&
"mov edx,[asm_umin + ebx] "&
"sub eax,edx "&
"cwd "&
"idiv ecx "&
"mov [thl15_deltax],eax "&
"jmp thl15_@do_stuff "&
"thl15_@bus_stop1: "&
"jmp thl15_@skip "&
"thl15_@do_stuff: "&
"mov eax,[asm_vmax + ebx] "&
"mov edx,[asm_vmin + ebx] "&
"sub eax,edx "&
"cwd "&
"idiv ecx "&
"mov ebp,eax "&
"mov eax,[asm_umin + ebx] "&
"mov edx,[asm_vmin + ebx] "&
"push ebx "&
"mov esi,thl15_texture "&
"mov ebx,ebp "&
"lea edi,[edi + ecx*2] "&
"xor ecx,-1 "&
"inc ecx "&
"thl15_@xloop: "&
"mov ebp,edx "&
"mov [thl15_dummy],eax "&
"mov dl,ah "&
"mov dx,word ptr [esi + edx*2] "&
"mov ax,word ptr [edi +ecx*2] "&
"shr eax,1 shr edx,1 "&
"and eax,15855 and edx,15855 add dx,ax "&		--15855 = 00111101 11101111 
"mov [edi + ecx*2],dx "&
"mov edx,ebp "&
"mov eax,[thl15_dummy] "&
"add edx,ebx "&
"add eax,[thl15_deltax] "&
"inc ecx "&
"jnz thl15_@xloop "&
"pop ebx "&
"pop edx "&
"thl15_@skip: "&
"add ebx,4 "&
"pop ecx "&
"add edx,[thl15_screenW] "&
"add edx,[thl15_screenW] "&
"dec cx "&
"jz thl15_@return "&
"mov eax,thl15_label_yloop "&
"jmp near eax "&
"thl15_@return: "&
"popa ret")
global constant thl15_mix_numlines=thl15_mix_code+get_param("thl15_numlines")
global constant thl15_mix_y=thl15_mix_code+get_param("thl15_y")
global constant thl15_mix_scraddr=thl15_mix_code+get_param("thl15_scraddr")
global constant thl15_mix_texture=thl15_mix_code+get_param("thl15_texture")
resolve_param("asm_xmax",asm_xmax)
resolve_param("asm_xmin",asm_xmin)
resolve_param("asm_umax",asm_umax)
resolve_param("asm_umin",asm_umin)
resolve_param("asm_vmax",asm_vmax)
resolve_param("asm_vmin",asm_vmin)
resolve_param("thl15_deltax",thl_deltaX)
resolve_param("thl15_screenW",rScreenW)
resolve_param("thl15_maxW",rMaxW)
resolve_param("thl15_dummy",rDummy)
resolve_param("thl15_label_yloop",thl15_mix_code+get_label("thl15_@yloop"))


global constant thl1516_tile_code=get_asm(
"pusha cld "&
"mov esi,thl_texture "&
"mov ecx,thl_numlines "&
"mov edx,thl_y "&
"lea ebx,[edx*4] "&
"mov eax,[thl_screenW] "&
"mul edx "&
"lea eax,[eax+eax] "&
"mov edx,eax "&
"thl_@yloop: "&
"push ecx "&
"mov edi,thl_scraddr "&
"add edi,edx "&
"mov eax,[asm_xmin + ebx] "&
"cmp eax,[thl_maxW] "&
"jng thl_@proceed_1 "&
"mov eax,thl_label_skip "&
"jmp near eax "&
"thl_@proceed_1: "&
"cmp eax,0 "&
"jnl thl_@xmin_nl_0 "&
"mov eax,0 "&
"thl_@xmin_nl_0: "&
"mov ecx,[asm_xmax + ebx] "&
"cmp ecx,0 "&
"jnl thl_@proceed_2 "&
"mov eax,thl_label_skip "&
"jmp near eax "&
"thl_@proceed_2: "&
"cmp ecx,[thl_maxW] "&
"jng thl_@xmax_ng_maxW "&
"mov ecx,[thl_maxW] "&
"thl_@xmax_ng_maxW: "&
"add edi,eax "&
"add edi,eax "&
"sub ecx,eax "&
"push edx "&
"inc ecx "&
"mov eax,[asm_umax + ebx] "&
"mov edx,[asm_umin + ebx] "&
"sub eax,edx "&
"cwd "&
"idiv ecx "&
"mov ebp,eax "&
"mov edx,eax "&
"shl eax,8 "&
"and eax,4160749568 "&
"shr ebp,1 "&
"and ebp,32767 "&
"and edx,458752 "&
"add eax,ebp "&
"add eax,edx "&
"or eax,133726208 "&
"mov [tiledudx],eax "&
"mov eax,[asm_vmax + ebx] "&
"mov edx,[asm_vmin + ebx] "&
"sub eax,edx "&
"cwd "&
"idiv ecx "&
"mov ebp,eax "&
"shl eax,3 "&
"and eax,133693440 "&
"shr ebp,1 "&
"and ebp,32767 "&
"add eax,ebp "&
"or eax,4161241088 "&
"mov [tiledvdx],eax "&
"mov ebp,[asm_umin + ebx] "&
"mov eax,ebp "&
"mov edx,eax "&
"shl ebp,8 "&
"and ebp,4160749568 "&
"shr eax,1 "&
"and eax,32767 "&
"and edx,458752 "&
"add ebp,eax "&
"add ebp,edx "&
"mov edx,[asm_vmin + ebx] "&
"mov eax,edx "&
"shl edx,3 "&
"and edx,133693440 "&
"shr eax,1 "&
"and eax,32767 "&
"add edx,eax "&
"push ebx "&
"mov ebx,edx "&
"lea edi,[edi + ecx*2] dec edi dec edi "&
"xor ecx,-1 "&
"inc ecx "&
"lea eax,[ebp+ebx] "&
"thl_@xloop: "&
"add ebp,[tiledudx] "&
"add ebx,[tiledvdx] "&
"shr eax,16 "&
"and ebp,4161241087 "&
"and ebx,133726207 "&
"mov dx,[esi + eax*2] "&
"mov [edi + ecx*2],dx "&
"lea eax,[ebp+ebx] "&
"inc ecx "&
"jnz thl_@xloop "&
"pop ebx "&
"pop edx "&
"thl_@skip: "&
"add ebx,4 "&
"pop ecx "&
"add edx,[thl_screenW] "&
"add edx,[thl_screenW] "&
"dec ecx "&
"jz thl_@return "&
"mov eax,thl_label_yloop "&
"jmp near eax "&
"thl_@return: "&
"popa ret")
global constant thl1516_tile_numlines=thl1516_tile_code+get_param("thl_numlines")
global constant thl1516_tile_y=thl1516_tile_code+get_param("thl_y")
global constant thl1516_tile_scraddr=thl1516_tile_code+get_param("thl_scraddr")
global constant thl1516_tile_texture=thl1516_tile_code+get_param("thl_texture")
resolve_param("asm_xmax",asm_xmax)
resolve_param("asm_xmin",asm_xmin)
resolve_param("asm_umax",asm_umax)
resolve_param("asm_umin",asm_umin)
resolve_param("asm_vmax",asm_vmax)
resolve_param("asm_vmin",asm_vmin)
resolve_param("tiledudx",thl_deltaX)
resolve_param("tiledvdx",thl_deltaY)
resolve_param("thl_screenW",rScreenW)
resolve_param("thl_maxW",rMaxW)
resolve_param("thl_label_yloop",thl1516_tile_code+get_label("thl_@yloop"))
resolve_param("thl_label_skip",thl1516_tile_code+get_label("thl_@skip"))


--*** Draw a number of textured horizontal lines (for use with texture poly-drawers). ***--
global constant thl24_code=get_asm(
"pusha cld "&
"mov ecx,thl24_numlines "&
"mov edx,thl24_y "&
"lea ebx,[edx*4] "&
"mov eax,[thl24_screenW] "&
"mul edx "&
"lea eax,[eax*2 + eax] "&
"mov edx,eax "&
"thl24_@yloop: "&
"push ecx "&
"mov edi,thl24_scraddr "&
"add edi,edx "&
"mov eax,[asm_xmin + ebx] "&
"cmp eax,[thl24_maxW] "&
"jng thl24_@proceed_1 "&
"mov eax thl24_label_skip "&
"jmp near eax "&
"thl24_@proceed_1: "&
"cmp eax,0 "&
"jnl thl24_@xmin_nl_0 "&
"mov eax,0 "&
"thl24_@xmin_nl_0: "&
"mov ecx,[asm_xmax + ebx] "&
"cmp ecx,0 "&
"jnl thl24_@proceed_2 "&
"mov eax thl24_label_skip "&
"jmp near eax "&
"thl24_@proceed_2: "&
"cmp ecx,[thl24_maxW] "&
"jng thl24_@xmax_ng_maxW "&
"mov ecx,[thl24_maxW] "&
"thl24_@xmax_ng_maxW: "&
"sub ecx,eax "&
"lea eax,[eax*2 + eax] "&
"add edi,eax "&
"push edx "&
"inc ecx "&
"mov eax,[asm_umax + ebx] "&
"mov edx,[asm_umin + ebx] "&
"sub eax,edx "&
"cwd "&
"idiv ecx "&
"mov [thl24_deltax],eax "&
"mov eax,[asm_vmax + ebx] "&
"mov edx,[asm_vmin + ebx] "&
"sub eax,edx "&
"cwd "&
"idiv ecx "&
"mov ebp,eax "&
"mov eax,[asm_umin + ebx] "&
"mov edx,[asm_vmin + ebx] "&
"push ebx "&
"mov esi,thl24_texture "&
"mov ebx,ebp "&
"thl24_@xloop: "&
"mov ebp,edx "&
"mov dl,ah "&
"lea edx,[edx*2 + edx] "&
"mov edx,[esi+edx] "&
"mov [edi],dx "&
"shr edx,16 "&
"mov [edi+2],dl "&
"mov edx,ebp "&
"add edx,ebx "&
"add eax,[thl24_deltax] "&
"add edi,3 "&
"loop thl24_@xloop "&
"pop ebx "&
"pop edx "&
"thl24_@skip: "&
"add ebx,4 "&
"pop ecx "&
"mov edi,[thl24_screenW] "&
"lea edi,[edi*2 + edi] "&
"add edx,edi "&
"dec cx "&
"jz thl24_@return "&
"mov eax,thl24_label_yloop "&
"jmp near eax "&
"thl24_@return: "&
"popa ret")
global constant thl24_numlines=thl24_code+get_param("thl24_numlines")
global constant thl24_y=thl24_code+get_param("thl24_y")
global constant thl24_scraddr=thl24_code+get_param("thl24_scraddr")
global constant thl24_texture=thl24_code+get_param("thl24_texture")
resolve_param("asm_xmax",asm_xmax)
resolve_param("asm_xmin",asm_xmin)
resolve_param("asm_umax",asm_umax)
resolve_param("asm_umin",asm_umin)
resolve_param("asm_vmax",asm_vmax)
resolve_param("asm_vmin",asm_vmin)
resolve_param("thl24_deltax",thl_deltaX)
resolve_param("thl24_screenW",rScreenW)
resolve_param("thl24_maxW",rMaxW)
resolve_param("thl24_label_yloop",thl24_code+get_label("thl24_@yloop"))
resolve_param("thl24_label_skip",thl24_code+get_label("thl24_@skip"))


global constant thl24_mix_code=get_asm(
"pusha cld "&
"mov ecx,thl24_numlines "&
"mov edx,thl24_y "&
"lea ebx,[edx*4] "&
"mov eax,[thl24_screenW] "&
"mul edx "&
"lea eax,[eax*2 + eax] "&
"mov edx,eax "&
"thl24_@yloop: "&
"push ecx "&
"mov edi,thl24_scraddr "&
"add edi,edx "&
"mov eax,[asm_xmin + ebx] "&
"cmp eax,[thl24_maxW] "&
"jng thl24_@proceed_1 "&
"mov eax thl24_label_skip "&
"jmp near eax "&
"thl24_@proceed_1: "&
"cmp eax,0 "&
"jnl thl24_@xmin_nl_0 "&
"mov eax,0 "&
"thl24_@xmin_nl_0: "&
"mov ecx,[asm_xmax + ebx] "&
"cmp ecx,0 "&
"jnl thl24_@proceed_2 "&
"mov eax thl24_label_skip "&
"jmp near eax "&
"thl24_@proceed_2: "&
"cmp ecx,[thl24_maxW] "&
"jng thl24_@xmax_ng_maxW "&
"mov ecx,[thl24_maxW] "&
"thl24_@xmax_ng_maxW: "&
"sub ecx,eax "&
"lea eax,[eax*2 + eax] "&
"add edi,eax "&
"push edx "&
"inc ecx "&
"mov eax,[asm_umax + ebx] "&
"mov edx,[asm_umin + ebx] "&
"sub eax,edx "&
"cwd "&
"idiv ecx "&
"mov [thl24_deltax],eax "&
"mov eax,[asm_vmax + ebx] "&
"mov edx,[asm_vmin + ebx] "&
"sub eax,edx "&
"cwd "&
"idiv ecx "&
"mov ebp,eax "&
"mov eax,[asm_umin + ebx] "&
"mov edx,[asm_vmin + ebx] "&
"push ebx "&
"mov esi,thl24_texture "&
"mov ebx,ebp "&
"thl24_@xloop: "&
"mov ebp,edx "&
"mov dl,ah "&
"mov [thl24_dummy],eax "&
"lea edx,[edx*2 + edx] "&
"mov edx,[esi+edx] "&
"mov eax,[edi] "&
"shr eax,1 shr edx,1 "&
"and eax,8355711 and edx,8355711 "&
"add edx,eax "&
"mov [edi],dx "&
"shr edx,16 "&
"mov [edi+2],dl "&
"mov eax,[thl24_dummy] "&
"mov edx,ebp "&
"add edx,ebx "&
"add eax,[thl24_deltax] "&
"add edi,3 "&
"loop thl24_@xloop "&
"pop ebx "&
"pop edx "&
"thl24_@skip: "&
"add ebx,4 "&
"pop ecx "&
"mov edi,[thl24_screenW] "&
"lea edi,[edi*2 + edi] "&
"add edx,edi "&
"dec cx "&
"jz thl24_@return "&
"mov eax,thl24_label_yloop "&
"jmp near eax "&
"thl24_@return: "&
"popa ret")
global constant thl24_mix_numlines=thl24_mix_code+get_param("thl24_numlines")
global constant thl24_mix_y=thl24_mix_code+get_param("thl24_y")
global constant thl24_mix_scraddr=thl24_mix_code+get_param("thl24_scraddr")
global constant thl24_mix_texture=thl24_mix_code+get_param("thl24_texture")
resolve_param("asm_xmax",asm_xmax)
resolve_param("asm_xmin",asm_xmin)
resolve_param("asm_umax",asm_umax)
resolve_param("asm_umin",asm_umin)
resolve_param("asm_vmax",asm_vmax)
resolve_param("asm_vmin",asm_vmin)
resolve_param("thl24_deltax",thl_deltaX)
resolve_param("thl24_screenW",rScreenW)
resolve_param("thl24_maxW",rMaxW)
resolve_param("thl24_dummy",rDummy)
resolve_param("thl24_label_yloop",thl24_mix_code+get_label("thl24_@yloop"))
resolve_param("thl24_label_skip",thl24_mix_code+get_label("thl24_@skip"))


global constant thl24_tile_code=get_asm(
"pusha cld "&
"mov esi,thl_texture "&
"mov ecx,thl_numlines "&
"mov edx,thl_y "&
"lea ebx,[edx*4] "&
"mov eax,[thl_screenW] "&
"mul edx "&
"lea eax,[eax*2 + eax] "&
"mov edx,eax "&
"thl_@yloop: "&
"push ecx "&
"mov edi,thl_scraddr "&
"add edi,edx "&
"mov eax,[asm_xmin + ebx] "&
"cmp eax,[thl_maxW] "&
"jng thl_@proceed_1 "&
"mov eax,thl_label_skip "&
"jmp near eax "&
"thl_@proceed_1: "&
"cmp eax,0 "&
"jnl thl_@xmin_nl_0 "&
"mov eax,0 "&
"thl_@xmin_nl_0: "&
"mov ecx,[asm_xmax + ebx] "&
"cmp ecx,0 "&
"jnl thl_@proceed_2 "&
"mov eax,thl_label_skip "&
"jmp near eax "&
"thl_@proceed_2: "&
"cmp ecx,[thl_maxW] "&
"jng thl_@xmax_ng_maxW "&
"mov ecx,[thl_maxW] "&
"thl_@xmax_ng_maxW: "&
"lea edi,[eax*2 + edi] "&
"add edi,eax "&
"sub ecx,eax "&
"push edx "&
"inc ecx "&
"mov eax,[asm_umax + ebx] "&
"mov edx,[asm_umin + ebx] "&
"sub eax,edx "&
"cwd "&
"idiv ecx "&
"mov ebp,eax "&
"mov edx,eax "&
"shl eax,8 "&
"and eax,4160749568 "&
"shr ebp,1 "&
"and ebp,32767 "&
"and edx,458752 "&
"add eax,ebp "&
"add eax,edx "&
"or eax,133726208 "&
"mov [tiledudx],eax "&
"mov eax,[asm_vmax + ebx] "&
"mov edx,[asm_vmin + ebx] "&
"sub eax,edx "&
"cwd "&
"idiv ecx "&
"mov ebp,eax "&
"shl eax,3 "&
"and eax,133693440 "&
"shr ebp,1 "&
"and ebp,32767 "&
"add eax,ebp "&
"or eax,4161241088 "&
"mov [tiledvdx],eax "&
"mov ebp,[asm_umin + ebx] "&
"mov eax,ebp "&
"mov edx,eax "&
"shl ebp,8 "&
"and ebp,4160749568 "&
"shr eax,1 "&
"and eax,32767 "&
"and edx,458752 "&
"add ebp,eax "&
"add ebp,edx "&
"mov edx,[asm_vmin + ebx] "&
"mov eax,edx "&
"shl edx,3 "&
"and edx,133693440 "&
"shr eax,1 "&
"and eax,32767 "&
"add edx,eax "&
"push ebx "&
"mov ebx,edx "&
"lea edi,[edi + ecx*2] add edi,ecx sub edi,3 "&
"xor ecx,-1 "&
"inc ecx "&
"lea eax,[ebp+ebx] "&
"thl_@xloop: "&
"mov [thl24_dummy],edi "&
"add edi,ecx "&
"add ebp,[tiledudx] "&
"add ebx,[tiledvdx] "&
"shr eax,16 "&
"and ebp,4161241087 "&
"and ebx,133726207 "&
"lea eax,[eax*2 + eax] "&
"mov dx,[esi + eax] "&
"mov [edi + ecx*2],dx "&
"inc eax inc edi inc eax inc edi "&
"mov dl,[esi + eax] "&
"mov [edi + ecx*2],dl "&
"lea eax,[ebp+ebx] "&
"mov edi,[thl24_dummy] "&
"inc ecx "&
"jnz thl_@xloop "&
"pop ebx "&
"pop edx "&
"thl_@skip: "&
"add ebx,4 "&
"pop ecx "&
"mov eax,[thl_screenW] "&
"lea eax,[eax*2 + eax] "&
"add edx,eax "&
--"add edx,[thl_screenW] "&
"dec ecx "&
"jz thl_@return "&
"mov eax,thl_label_yloop "&
"jmp near eax "&
"thl_@return: "&
"popa ret")
global constant thl24_tile_numlines=thl24_tile_code+get_param("thl_numlines")
global constant thl24_tile_y=thl24_tile_code+get_param("thl_y")
global constant thl24_tile_scraddr=thl24_tile_code+get_param("thl_scraddr")
global constant thl24_tile_texture=thl24_tile_code+get_param("thl_texture")
resolve_param("asm_xmax",asm_xmax)
resolve_param("asm_xmin",asm_xmin)
resolve_param("asm_umax",asm_umax)
resolve_param("asm_umin",asm_umin)
resolve_param("asm_vmax",asm_vmax)
resolve_param("asm_vmin",asm_vmin)
resolve_param("tiledudx",thl_deltaX)
resolve_param("tiledvdx",thl_deltaY)
resolve_param("thl_screenW",rScreenW)
resolve_param("thl_maxW",rMaxW)
resolve_param("thl24_dummy",rDummy)
resolve_param("thl_label_yloop",thl24_tile_code+get_label("thl_@yloop"))
resolve_param("thl_label_skip",thl24_tile_code+get_label("thl_@skip"))


--** </Poly fillers> **--


--** <Linear interpolators> **--

--STRUCT sps_data {
-- DWORD x1,x2,y1,y2
--}
global constant sps_data=allocate(16)

--** scan_poly_side **--
global constant sps_code=get_asm(
"pusha cld "&
"mov eax,[sps_y2] "&
"mov ebx,[sps_y1] "&
"cmp eax,ebx "&
"jne sps_@do_stuff "&
"popa ret "&
"sps_@do_stuff: "&
"cmp eax,ebx "&
"jnl sps_@y2_nl_y1 "&
"mov [sps_y2],ebx "&
"mov [sps_y1],eax "&
"mov eax,[sps_x2] "&
"mov ebx,[sps_x1] "&
"mov [sps_x2],ebx "&
"mov [sps_x1],eax "&
"sps_@y2_nl_y1: "&
"mov eax,[sps_x2] "&
"sub eax,[sps_x1] "&
"sal eax,7 "&
"cwd "&
"mov ebx,[sps_y2] "&
"sub ebx,[sps_y1] "&
"idiv ebx "&
"mov edi,eax "&
"mov edx,[sps_x1] "&
"sal edx,7 "&
"mov ebx,[sps_y2] "&
"inc ebx "&
"mov ecx,[sps_y1] "&
"sps_@loop: "&
"cmp ecx,0 "&
"jl sps_@skip "&
"cmp ecx,[sps_screenH] "&
"jge sps_@skip "&
"mov ebp,ecx "&
"mov esi,edx "&
"sar edx,7 "&
"lea ecx,[ecx*4] "&
"cmp edx,[sps_xmin + ecx] "&
"jnl sps_@x_nl_xmin "&
"mov [sps_xmin + ecx],edx "&
"sps_@x_nl_xmin: "&
"cmp edx,[sps_xmax + ecx] "&
"jng sps_@x_ng_xmax "&
"mov [sps_xmax + ecx],edx "&
"sps_@x_ng_xmax: "&
"mov ecx,ebp "&
"mov edx,esi "&
"sps_@skip: "&
"add edx,edi "&
"inc ecx "&
"cmp ecx,ebx "&
"jne sps_@loop "&
"popa ret")
resolve_param("sps_x1",sps_data)
resolve_param("sps_x2",sps_data+4)
resolve_param("sps_y1",sps_data+8)
resolve_param("sps_y2",sps_data+12)
resolve_param("sps_xmin",asm_xmin)
resolve_param("sps_xmax",asm_xmax)
resolve_param("sps_screenH",rScreenH)


--STRUCT sgps_data {
-- DWORD x1,x2,y1,y2
-- DWORD c1,c2
--}
global constant sgps_data=allocate(24)

--** scan_gouraudpoly_side **--
global constant sgps_code=get_asm(
"pusha cld "&
"mov eax,[sgps_y2] "&
"mov ebx,[sgps_y1] "&
"cmp eax,ebx "&
"jne sgps_@do_stuff "&
"popa ret "&
"sgps_@do_stuff: "&
"cmp eax,ebx "&
"jnl sgps_@y2_nl_y1 "&
"mov [sgps_y2],ebx "&
"mov [sgps_y1],eax "&
"mov eax,[sgps_x2] "&
"mov ebx,[sgps_x1] "&
"mov [sgps_x2],ebx "&
"mov [sgps_x1],eax "&
"mov eax,[sgps_c2] "&
"mov ebx,[sgps_c1] "&
"mov [sgps_c2],ebx "&
"mov [sgps_c1],eax "&
"sgps_@y2_nl_y1: "&
"mov eax,[sgps_c2] "&
"sub eax,[sgps_c1] "&
"sal eax,8 "&
"cwd "&
"mov ebx,[sgps_y2] "&
"sub ebx,[sgps_y1] "&
"idiv ebx "&
"mov edi,eax "&
"mov eax,[sgps_x2] "&
"sub eax,[sgps_x1] "&
"sal eax,7 "&
"cwd "&
"idiv ebx "&
"mov esi,eax "&
"mov ebp,[sgps_c1] "&
"sal ebp,8 "&
"mov edx,[sgps_x1] "&
"sal edx,7 "&
"mov ebx,[sgps_y2] "&
"inc ebx "&
"mov ecx,[sgps_y1] "&
"sgps_@loop: "&
"cmp ecx,0 "&
"jl sgps_@skip "&
"cmp ecx,[sgps_screenH] "&
"jge sgps_@skip "&
"push edx "&
"push ecx "&
"sar edx,7 "&
"lea ecx,[ecx*4] "&
"cmp edx,[sgps_xmin + ecx] "&
"jnl sgps_@x_nl_xmin "&
"mov [sgps_xmin + ecx],edx "&
"mov [sgps_cmin + ecx],ebp "&
"sgps_@x_nl_xmin: "&
"cmp edx,[sgps_xmax + ecx] "&
"jng sgps_@x_ng_xmax "&
"mov [sgps_xmax + ecx],edx "&
"mov [sgps_cmax + ecx],ebp "&
"sgps_@x_ng_xmax: "&
"pop ecx "&
"pop edx "&
"sgps_@skip: "&
"add edx,esi "&
"add ebp,edi "&
"inc ecx "&
"cmp ecx,ebx "&
"jne sgps_@loop "&
"popa ret")
resolve_param("sgps_x1",sgps_data)
resolve_param("sgps_x2",sgps_data+4)
resolve_param("sgps_y1",sgps_data+8)
resolve_param("sgps_y2",sgps_data+12)
resolve_param("sgps_c1",sgps_data+16)
resolve_param("sgps_c2",sgps_data+20)
resolve_param("sgps_xmin",asm_xmin)
resolve_param("sgps_xmax",asm_xmax)
resolve_param("sgps_cmin",asm_cmin)
resolve_param("sgps_cmax",asm_cmax)
resolve_param("sgps_screenH",rScreenH)


--STRUCT sgps16_data {
-- DWORD x1,x2,y1,y2
-- DWORD c1,c2
-- DWORD r,g,b
-- DWORD dr,dg,rb
--}
global constant sgps16_data=allocate(48)

--** scan_gouraudpoly_side **--
global constant sgps16_code=get_asm(
"pusha cld "&
"mov eax,[sgps16_y2] "&
"mov ebx,[sgps16_y1] "&
"cmp eax,ebx "&
"jne sgps16_@do_stuff "&
"popa ret "&
"sgps16_@do_stuff: "&
"cmp eax,ebx "&
"jnl sgps16_@y2_nl_y1 "&
"mov [sgps16_y2],ebx "&
"mov [sgps16_y1],eax "&
"mov eax,[sgps16_x2] "&
"mov ebx,[sgps16_x1] "&
"mov [sgps16_x2],ebx "&
"mov [sgps16_x1],eax "&
"mov eax,[sgps16_c2] "&
"mov ebx,[sgps16_c1] "&
"mov [sgps16_c2],ebx "&
"mov [sgps16_c1],eax "&
"sgps16_@y2_nl_y1: "&
"mov ecx,[sgps16_y2] "&
"sub ecx,[sgps16_y1] "&
"mov eax,[sgps16_c2] "&
"mov ebx,[sgps16_c1] "&
"and eax,31 "&				--31 = 00000000 00011111b
"and ebx,31 "&
"sub eax,ebx "&
"sal eax,11 shl ebx,11 "&
"mov [sgps16_r],ebx "&			--sgps16_r = 0RRRRRxx xxxxxxxxb 
"cwd "&
"idiv ecx "&
"mov [sgps16_dr],eax "&
"mov eax,[sgps16_c2] "&
"mov ebx,[sgps16_c1] "&
"and eax,2016 "&				--2016 = 00000111 11100000b 
"and ebx,2016 "&
"sub eax,ebx "&
"sal eax,5 "&
"shl ebx,5 "&
"mov [sgps16_g],ebx "&			--sgps16_g = 0GGGGGGx xxxxxxxxb
"cwd "&
"idiv ecx "&
"mov [sgps16_dg],eax "&
"mov eax,[sgps16_c2] "&
"mov ebx,[sgps16_c1] "&
"and eax,63488 "&				--63488 = 11111000 00000000b
"and ebx,63488 "&
"sub eax,ebx "&
"mov [sgps16_b],ebx "&			--sgps16_b = 0BBBBBxx xxxxxxxxb
"cwd "&
"idiv ecx "&
"mov [sgps16_db],eax "&
"mov eax,[sgps16_x2] "&
"sub eax,[sgps16_x1] "&
"sal eax,7 "&
"cwd "&
"idiv ecx "&
"mov esi,eax "&
"mov ebp,[sgps16_x1] "&
"sal ebp,7 "&
"mov ebx,[sgps16_y2] "&
"inc ebx "&
"mov ecx,[sgps16_y1] "&
"sgps16_@loop: "&
"cmp ecx,0 "&
"jl sgps16_@skip "&
"cmp ecx,[sgps16_screenH] "&
"jge sgps16_@skip "&

"mov edx,[sgps16_r] "&				--dx = RRRRRxxx xxxxxxxx
"shr edx,11 "&					--dx = 00000000 000RRRRR
"mov eax,[sgps16_g] "&				--ax = GGGGGGxx xxxxxxxx
"and eax,64512 "&					--ax = GGGGGG00 00000000
"shr eax,5 "&					--ax = 00000GGG GGG00000
"or eax,edx "&					--ax = 000000GG GGGRRRRR
"mov edx,[sgps16_b] "&				--dx = BBBBBxxx xxxxxxxx
"and edx,63488 "&					--dx = BBBBB000 00000000
"or eax,edx "&					--ax = BBBBBGGG GGGRRRRR

"push ebp "&
"push ecx "&
"sar ebp,7 "&
"lea ecx,[ecx*4] "&
"jmp sgps16_@do_stuff2 "&
"sgps16_@bus_stop: "&
"jmp sgps16_@loop "&
"sgps16_@do_stuff2: "&
"cmp ebp,[sgps16_xmin + ecx] "&
"jnl sgps16_@x_nl_xmin "&
"mov [sgps16_xmin + ecx],ebp "&
"mov [sgps16_cmin + ecx],eax "&
"sgps16_@x_nl_xmin: "&
"cmp ebp,[sgps16_xmax + ecx] "&
"jng sgps16_@x_ng_xmax "&
"mov [sgps16_xmax + ecx],ebp "&
"mov [sgps16_cmax + ecx],eax "&
"sgps16_@x_ng_xmax: "&
"pop ecx "&
"pop ebp "&
--"mov edx,[esp] "&
--"mov ebp,[esp + 4] "&
--"add esp,8 "&
"sgps16_@skip: "&
"add ebp,esi "&
"mov edi,[sgps16_dr] "&
"add [sgps16_r],edi "&
"mov edi,[sgps16_dg] "&
"add [sgps16_g],edi "&
"mov edi,[sgps16_db] "&
"add [sgps16_b],edi "&
"inc ecx "&
"cmp ecx,ebx "&
"je sgps16_@done "&
"jmp sgps16_@bus_stop "&
"sgps16_@done: "&
"popa ret")
resolve_param("sgps16_x1",sgps16_data)
resolve_param("sgps16_x2",sgps16_data+4)
resolve_param("sgps16_y1",sgps16_data+8)
resolve_param("sgps16_y2",sgps16_data+12)
resolve_param("sgps16_c1",sgps16_data+16)
resolve_param("sgps16_c2",sgps16_data+20)
resolve_param("sgps16_r",sgps16_data+24)
resolve_param("sgps16_g",sgps16_data+28)
resolve_param("sgps16_b",sgps16_data+32)
resolve_param("sgps16_dr",sgps16_data+36)
resolve_param("sgps16_dg",sgps16_data+40)
resolve_param("sgps16_db",sgps16_data+44)
resolve_param("sgps16_xmin",asm_xmin)
resolve_param("sgps16_xmax",asm_xmax)
resolve_param("sgps16_cmin",asm_cmin)
resolve_param("sgps16_cmax",asm_cmax)
resolve_param("sgps16_screenH",rScreenH)


--** scan_gouraudpoly_side **--
global constant sgps15_code=get_asm(
"pusha cld "&
"mov eax,[sgps15_y2] "&
"mov ebx,[sgps15_y1] "&
"cmp eax,ebx "&
"jne sgps15_@do_stuff "&
"popa ret "&
"sgps15_@do_stuff: "&
"cmp eax,ebx "&
"jnl sgps15_@y2_nl_y1 "&
"mov [sgps15_y2],ebx "&
"mov [sgps15_y1],eax "&
"mov eax,[sgps15_x2] "&
"mov ebx,[sgps15_x1] "&
"mov [sgps15_x2],ebx "&
"mov [sgps15_x1],eax "&
"mov eax,[sgps15_c2] "&
"mov ebx,[sgps15_c1] "&
"mov [sgps15_c2],ebx "&
"mov [sgps15_c1],eax "&
"sgps15_@y2_nl_y1: "&
"mov ecx,[sgps15_y2] "&
"sub ecx,[sgps15_y1] "&
"mov eax,[sgps15_c2] "&
"mov ebx,[sgps15_c1] "&
"and eax,31 "&				--31 = 00000000 00011111b
"and ebx,31 "&
"sub eax,ebx "&
"sal eax,10 shl ebx,10 "&
"mov [sgps15_r],ebx "&			--sgps15_r = RRRRRxxx xxxxxxxxb 
"cwd "&
"idiv ecx "&
"mov [sgps15_dr],eax "&
"mov eax,[sgps15_c2] "&
"mov ebx,[sgps15_c1] "&
"and eax,992 "&				--992 = 00000011 11100000b 
"and ebx,992 "&
"sub eax,ebx "&
"sal eax,5 "&
"shl ebx,5 "&
"mov [sgps15_g],ebx "&			--sgps15_g = GGGGGxxx xxxxxxxxb
"cwd "&
"idiv ecx "&
"mov [sgps15_dg],eax "&
"mov eax,[sgps15_c2] "&
"mov ebx,[sgps15_c1] "&
"and eax,31744 "&				--31744 = 01111100 00000000b
"and ebx,31744 "&
--"sal eax,1 shl ebx,1 "&
"sub eax,ebx "&
"mov [sgps15_b],ebx "&			--sgps15_b = BBBBBxxx xxxxxxxxb
"cwd "&
"idiv ecx "&
"mov [sgps15_db],eax "&
"mov eax,[sgps15_x2] "&
"sub eax,[sgps15_x1] "&
"sal eax,7 "&
"cwd "&
"idiv ecx "&
"mov esi,eax "&
"mov ebp,[sgps15_x1] "&
"sal ebp,7 "&
"mov ebx,[sgps15_y2] "&
"inc ebx "&
"mov ecx,[sgps15_y1] "&
"sgps15_@loop: "&
"cmp ecx,0 "&
"jl sgps15_@skip "&
"cmp ecx,[sgps15_screenH] "&
"jge sgps15_@skip "&

"mov edx,[sgps15_r] "&				--dx = 0RRRRRxx xxxxxxxx
"shr edx,10 "&					--dx = 00000000 000RRRRR
--"and edx,31 "&					--dx = 
"mov eax,[sgps15_g] "&				--ax = 0GGGGGxx xxxxxxxx
"and eax,31744 "&					--ax = 0GGGGG00 00000000
"shr eax,5 "&					--ax = 000000GG GGG00000
"or eax,edx "&					--ax = 000000GG GGGRRRRR
"mov edx,[sgps15_b] "&				--dx = 0BBBBBxx xxxxxxxx
"and edx,31744 "&					--dx = 0BBBBB00 00000000
"or eax,edx "&					--ax = 0BBBBBGG GGGRRRRR	

"push ebp "&
"push ecx "&
"sar ebp,7 "&
"lea ecx,[ecx*4] "&
"cmp ebp,[sgps15_xmin + ecx] "&
"jnl sgps15_@x_nl_xmin "&
"mov [sgps15_xmin + ecx],ebp "&
"mov [sgps15_cmin + ecx],eax "&
"sgps15_@x_nl_xmin: "&
"cmp ebp,[sgps15_xmax + ecx] "&
"jng sgps15_@x_ng_xmax "&
"mov [sgps15_xmax + ecx],ebp "&
"mov [sgps15_cmax + ecx],eax "&
"sgps15_@x_ng_xmax: "&
"pop ecx "&
"pop ebp "&
"sgps15_@skip: "&
"add ebp,esi "&
"mov edi,[sgps15_dr] "&
"add [sgps15_r],edi "&
"mov edi,[sgps15_dg] "&
"add [sgps15_g],edi "&
"mov edi,[sgps15_db] "&
"add [sgps15_b],edi "&
"inc ecx "&
"cmp ecx,ebx "&
"je sgps15_@done "&
"mov eax,sgps15_label_loop "&
"jmp near eax "&
"sgps15_@done: "&
"popa ret")
resolve_param("sgps15_x1",sgps16_data)
resolve_param("sgps15_x2",sgps16_data+4)
resolve_param("sgps15_y1",sgps16_data+8)
resolve_param("sgps15_y2",sgps16_data+12)
resolve_param("sgps15_c1",sgps16_data+16)
resolve_param("sgps15_c2",sgps16_data+20)
resolve_param("sgps15_r",sgps16_data+24)
resolve_param("sgps15_g",sgps16_data+28)
resolve_param("sgps15_b",sgps16_data+32)
resolve_param("sgps15_dr",sgps16_data+36)
resolve_param("sgps15_dg",sgps16_data+40)
resolve_param("sgps15_db",sgps16_data+44)
resolve_param("sgps15_xmin",asm_xmin)
resolve_param("sgps15_xmax",asm_xmax)
resolve_param("sgps15_cmin",asm_cmin)
resolve_param("sgps15_cmax",asm_cmax)
resolve_param("sgps15_screenH",rScreenH)
resolve_param("sgps15_label_loop",sgps15_code+get_label("sgps15_@loop"))


global constant sgps24_code=get_asm(
"pusha cld "&
"mov eax,[sgps24_y2] "&
"mov ebx,[sgps24_y1] "&
"cmp eax,ebx "&
"jne sgps24_@do_stuff "&
"popa ret "&
"sgps24_@do_stuff: "&
"cmp eax,ebx "&
"jnl sgps24_@y2_nl_y1 "&
"mov [sgps24_y2],ebx "&
"mov [sgps24_y1],eax "&
"mov eax,[sgps24_x2] "&
"mov ebx,[sgps24_x1] "&
"mov [sgps24_x2],ebx "&
"mov [sgps24_x1],eax "&
"mov eax,[sgps24_c2] "&
"mov ebx,[sgps24_c1] "&
"mov [sgps24_c2],ebx "&
"mov [sgps24_c1],eax "&
"sgps24_@y2_nl_y1: "&
"mov ecx,[sgps24_y2] "&
"sub ecx,[sgps24_y1] "&
"mov eax,[sgps24_c2] "&
"mov ebx,[sgps24_c1] "&
"and eax,255 "&
"and ebx,255 "&
"sub eax,ebx "&
"sal eax,8 "&
"shl ebx,8 "&
"mov [sgps24_r],ebx "&			--sgps16_r = RRRRRxxx xxxxxxxxb 
"cwd "&
"idiv ecx "&
"mov [sgps24_dr],eax "&
"mov eax,[sgps24_c2] "&
"mov ebx,[sgps24_c1] "&
"and eax,65280 "&
"and ebx,65280 "&
"sub eax,ebx "&
"mov [sgps24_g],ebx "&			--sgps16_g = GGGGGxxx xxxxxxxxb
"cwd "&
"idiv ecx "&
"mov [sgps24_dg],eax "&
"mov eax,[sgps24_c2] "&
"mov ebx,[sgps24_c1] "&
"and eax,16711680 "&
"and ebx,16711680 "&
"sub eax,ebx "&
"sar eax,8 "&
"shr ebx,8 "&
"mov [sgps24_b],ebx "&			--sgps16_b = BBBBBxxx xxxxxxxxb
"cwd "&
"idiv ecx "&
"mov [sgps24_db],eax "&
"mov eax,[sgps24_x2] "&
"sub eax,[sgps24_x1] "&
"sal eax,6 sal eax,1 "&
"cwd "&
"idiv ecx "&
"mov esi,eax "&
"mov ebp,[sgps24_x1] "&
"sal ebp,6 sal ebp,1"&
"mov ebx,[sgps24_y2] "&
"inc ebx "&
"mov ecx,[sgps24_y1] "&
"sgps24_@loop: "&
"cmp ecx,0 "&
"jl sgps24_@skip "&
"cmp ecx,[sgps24_screenH] "&
"jge sgps24_@skip "&
"mov eax,[sgps24_r] "&			--eax = 00000000 00000000 RRRRRRRR xxxxxxxx
"shl eax,8 "&				--eax = 00000000 RRRRRRRR xxxxxxxx 00000000
--"mov edx,[sgps24_g] "&			--edx = 00000000 00000000 GGGGGGGG xxxxxxxx
--"mov ah,dh "&				--eax = 00000000 RRRRRRRR GGGGGGGG xxxxxxxx
"mov ah,[sgps24_g + 1] "&
--"mov edx,[sgps24_b] "&			--edx = 00000000 00000000 BBBBBBBB xxxxxxxx
--"mov al,dh "&				--eax = 00000000 RRRRRRRR GGGGGGGG BBBBBBBB
"mov al,[sgps24_b + 1] "&
"push ebp "&
"push ecx "&
"sar ebp,6 sar ebp,1"&
"lea ecx,[ecx*4] "&
"cmp ebp,[sgps24_xmin + ecx] "&
"jnl sgps24_@x_nl_xmin "&
"mov [sgps24_xmin + ecx],ebp "&
"mov [sgps24_cmin + ecx],eax "&
"sgps24_@x_nl_xmin: "&
"cmp ebp,[sgps24_xmax + ecx] "&
"jng sgps24_@x_ng_xmax "&
"mov [sgps24_xmax + ecx],ebp "&
"mov [sgps24_cmax + ecx],eax "&
"sgps24_@x_ng_xmax: "&
"pop ecx "&
"pop ebp "&
"sgps24_@skip: "&
"add ebp,esi "&
"mov edi,[sgps24_dr] "&
"add [sgps24_r],edi "&
"mov edi,[sgps24_dg] "&
"add [sgps24_g],edi "&
"mov edi,[sgps24_db] "&
"add [sgps24_b],edi "&
"inc ecx "&
"cmp ecx,ebx "&
"je sgps24_@done "&
"mov eax,sgps24_label_loop "&
"jmp near eax "&
"sgps24_@done: "&
"popa ret")
resolve_param("sgps24_x1",sgps16_data)
resolve_param("sgps24_x2",sgps16_data+4)
resolve_param("sgps24_y1",sgps16_data+8)
resolve_param("sgps24_y2",sgps16_data+12)
resolve_param("sgps24_c1",sgps16_data+16)
resolve_param("sgps24_c2",sgps16_data+20)
resolve_param("sgps24_r",sgps16_data+24)
resolve_param("sgps24_g",sgps16_data+28)
resolve_param("sgps24_b",sgps16_data+32)
resolve_param("sgps24_dr",sgps16_data+36)
resolve_param("sgps24_dg",sgps16_data+40)
resolve_param("sgps24_db",sgps16_data+44)
resolve_param("sgps24_xmin",asm_xmin)
resolve_param("sgps24_xmax",asm_xmax)
resolve_param("sgps24_cmin",asm_cmin)
resolve_param("sgps24_cmax",asm_cmax)
resolve_param("sgps24_screenH",rScreenH)
resolve_param("sgps24_label_loop",sgps24_code+get_label("sgps24_@loop"))




--STRUCT stps_data {
-- DWORD x1,x2,y1,y2
-- DWORD u1,u2,v1,v2
-- DWORD deltaX,deltaU,deltaV
--}
global constant stps_data=allocate(44)

--** scan_texturepoly_side **--
global constant stps_code=get_asm(
"pusha cld "&
"mov eax,[stps_y2] "&
"mov ebx,[stps_y1] "&
"cmp eax,ebx "&
"jne stps_@do_stuff "&
"popa ret "&
"stps_@do_stuff: "&
"cmp eax,ebx "&
"jnl stps_@y2_nl_y1 "&
"mov [stps_y2],ebx "&
"mov [stps_y1],eax "&
"mov ebx,[stps_x1] "&
"mov eax,[stps_x2] "&
"mov [stps_x2],ebx "&
"mov [stps_x1],eax "&
"mov eax,[stps_u2] "&
"mov ebx,[stps_u1] "&
"mov [stps_u1],eax "&
"mov [stps_u2],ebx "&
"mov eax,[stps_v2] "&
"mov ebx,[stps_v1] "&
"mov [stps_v1],eax "&
"mov [stps_v2],ebx "&
"stps_@y2_nl_y1: "&
"mov eax,[stps_u2] "&
"mov ebx,[stps_y2] "&
"sub eax,[stps_u1] "&
"sub ebx,[stps_y1] "&
"sal eax,8 "&
"cwd "&
"idiv ebx "&
"mov [stps_deltaU],eax "&
"mov eax,[stps_v2] "&
"sub eax,[stps_v1] "&
"sal eax,8 "&
"cwd "&
"idiv ebx "&
"mov [stps_deltaV],eax "&
"mov eax,[stps_x2] "&
"sub eax,[stps_x1] "&
"sal eax,9 "&
"cwd "&
"idiv ebx "&
"mov [stps_deltaX],eax "&
"mov ebp,[stps_u1] "&
"sal ebp,8 "&
"mov esi,[stps_v1] "&
"sal esi,8 "&
"mov edx,[stps_x1] "&
"sal edx,8 sal edx,1 "&
"mov edi,[stps_y2] "&
"inc edi "&
"mov ecx,[stps_y1] "&
"mov ebx,[stps_deltaU] "&
"mov eax,[stps_deltaX] "&
"stps_@loop: "&
"cmp ecx,0 "&
"jl stps_@skip "&
"cmp ecx,[stps_screenH] "&
"jge stps_@skip "&
"push edx "&
"push ecx "&
"sar edx,8 sar edx,1 "&
"lea ecx,[ecx*4] "&
"cmp edx,[stps_xmin + ecx] "&
"jnl stps_@x_nl_xmin "&
"mov [stps_xmin + ecx],edx "&
"mov [stps_umin + ecx],ebp "&
"mov [stps_vmin + ecx],esi "&
"stps_@x_nl_xmin: "&
"cmp edx,[stps_xmax + ecx] "&
"jng stps_@x_ng_xmax "&
"mov [stps_xmax + ecx],edx "&
"mov [stps_umax + ecx],ebp "&
"mov [stps_vmax + ecx],esi "&
"stps_@x_ng_xmax: "&
"pop ecx "&
"pop edx "&
"stps_@skip: "&
"add edx,eax "&
"add ebp,ebx "&
"add esi,[stps_deltaV] "&
"inc ecx "&
"cmp ecx,edi "&
"jne stps_@loop "&
"popa ret")
resolve_param("stps_x1",stps_data)
resolve_param("stps_x2",stps_data+4)
resolve_param("stps_y1",stps_data+8)
resolve_param("stps_y2",stps_data+12)
resolve_param("stps_u1",stps_data+16)
resolve_param("stps_u2",stps_data+20)
resolve_param("stps_v1",stps_data+24)
resolve_param("stps_v2",stps_data+28)
resolve_param("stps_deltaX",stps_data+32)
resolve_param("stps_deltaU",stps_data+36)
resolve_param("stps_deltaV",stps_data+40)
resolve_param("stps_xmin",asm_xmin)
resolve_param("stps_xmax",asm_xmax)
resolve_param("stps_umin",asm_umin)
resolve_param("stps_umax",asm_umax)
resolve_param("stps_vmin",asm_vmin)
resolve_param("stps_vmax",asm_vmax)
resolve_param("stps_screenH",rScreenH)


global constant stps_tile_code=get_asm(
"pusha cld "&
"mov eax,[stps_y2] "&
"mov ebx,[stps_y1] "&
"cmp eax,ebx "&
"jne stps_@do_stuff "&
"popa ret "&
"stps_@do_stuff: "&
"cmp eax,ebx "&
"jnl stps_@y2_nl_y1 "&
"mov [stps_y2],ebx "&
"mov [stps_y1],eax "&
"mov ebx,[stps_x1] "&
"mov eax,[stps_x2] "&
"mov [stps_x2],ebx "&
"mov [stps_x1],eax "&
"mov eax,[stps_u2] "&
"mov ebx,[stps_u1] "&
"mov [stps_u1],eax "&
"mov [stps_u2],ebx "&
"mov eax,[stps_v2] "&
"mov ebx,[stps_v1] "&
"mov [stps_v1],eax "&
"mov [stps_v2],ebx "&
"stps_@y2_nl_y1: "&
"mov eax,[stps_u2] "&
"mov ebx,[stps_y2] "&
"sub eax,[stps_u1] "&
"sub ebx,[stps_y1] "&
"sal eax,16 "&
"cwd "&
"idiv ebx "&
"mov [stps_deltaU],eax "&
"mov eax,[stps_v2] "&
"sub eax,[stps_v1] "&
"sal eax,16 "&
"cwd "&
"idiv ebx "&
"mov [stps_deltaV],eax "&
"mov eax,[stps_x2] "&
"sub eax,[stps_x1] "&
"sal eax,8 sal eax,1 "&
"cwd "&
"idiv ebx "&
"mov [stps_deltaX],eax "&
"mov ebp,[stps_u1] "&
"sal ebp,16 "&
"mov esi,[stps_v1] "&
"sal esi,16 "&
"mov edx,[stps_x1] "&
"sal edx,8 sal edx,1 "&
"mov edi,[stps_y2] "&
"inc edi "&
"mov ecx,[stps_y1] "&
"mov ebx,[stps_deltaU] "&
"mov eax,[stps_deltaX] "&
"stps_@loop: "&
"cmp ecx,0 "&
"jl stps_@skip "&
"cmp ecx,[stps_screenH] "&
"jge stps_@skip "&
"push edx "&
"push ecx "&
"sar edx,8 sar edx,1 "&
"lea ecx,[ecx*4] "&
"cmp edx,[stps_xmin + ecx] "&
"jnl stps_@x_nl_xmin "&
"mov [stps_xmin + ecx],edx "&
"mov [stps_umin + ecx],ebp "&
"mov [stps_vmin + ecx],esi "&
"stps_@x_nl_xmin: "&
"cmp edx,[stps_xmax + ecx] "&
"jng stps_@x_ng_xmax "&
"mov [stps_xmax + ecx],edx "&
"mov [stps_umax + ecx],ebp "&
"mov [stps_vmax + ecx],esi "&
"stps_@x_ng_xmax: "&
"pop ecx "&
"pop edx "&
"stps_@skip: "&
"add edx,eax "&
"add ebp,ebx "&
"add esi,[stps_deltaV] "&
"inc ecx "&
"cmp ecx,edi "&
"jne stps_@loop "&
"popa ret")
resolve_param("stps_x1",stps_data)
resolve_param("stps_x2",stps_data+4)
resolve_param("stps_y1",stps_data+8)
resolve_param("stps_y2",stps_data+12)
resolve_param("stps_u1",stps_data+16)
resolve_param("stps_u2",stps_data+20)
resolve_param("stps_v1",stps_data+24)
resolve_param("stps_v2",stps_data+28)
resolve_param("stps_deltaX",stps_data+32)
resolve_param("stps_deltaU",stps_data+36)
resolve_param("stps_deltaV",stps_data+40)
resolve_param("stps_xmin",asm_xmin)
resolve_param("stps_xmax",asm_xmax)
resolve_param("stps_umin",asm_umin)
resolve_param("stps_umax",asm_umax)
resolve_param("stps_vmin",asm_vmin)
resolve_param("stps_vmax",asm_vmax)
resolve_param("stps_screenH",rScreenH)



global constant reset_minmax_buffers=get_asm(
"pusha cld "&
"mov edi,rmmb_xmin "&
"mov ecx,[rmmb_screenH] "&
"mov eax,8000 "&
"rep stosd "&
"neg eax "&
"mov edi,rmmb_xmax "&
"mov ecx,[rmmb_screenH] "&
"rep stosd "&
"popa ret")
resolve_param("rmmb_xmin",asm_xmin)
resolve_param("rmmb_xmax",asm_xmax)
resolve_param("rmmb_screenH",rScreenH)


--** </Assembly code> **--



--** <Main routines> (experimental versions.  ...kinda.) **--

global procedure render_mixtable(atom table)
 if table>0 then
  rMixTb=table
  poke4(thl_mix_lup,rMixTb)
 end if
end procedure


global procedure asm_tri_ex(sequence triCoords,integer triCol,atom triAddr)
integer ymin,ymax
 call(reset_minmax_buffers)
 poke4(sps_data,{triCoords[1][1],triCoords[2][1],triCoords[1][2],triCoords[2][2]})
 call(sps_code)
 poke4(sps_data,{triCoords[2][1],triCoords[3][1],triCoords[2][2],triCoords[3][2]})
 call(sps_code)
 poke4(sps_data,{triCoords[3][1],triCoords[1][1],triCoords[3][2],triCoords[1][2]})
 call(sps_code)
 ymin=triCoords[1][2]
 ymax=ymin
 for i=2 to 3 do
  if triCoords[i][2]<ymin then ymin=triCoords[i][2] end if
  if triCoords[i][2]>ymax then ymax=triCoords[i][2] end if
 end for 
 if (ymax>=0 and ymin<render_screenH) then
  if ymin<0 then ymin=0 end if
  if ymax>render_maxH then ymax=render_maxH end if
  poke4(flat_y,ymin)
  poke4(flat_numlines,(ymax-ymin)+1)
   if render_bytesPerPixel=1 then
   poke(flat_color,{triCol,triCol,triCol,triCol})
  elsif render_bytesPerPixel=3 then
   poke4(flat_color,triCol)
  else
   poke_word(flat_color,{triCol,triCol})
  end if
  poke4(flat_scraddr,triAddr)
  call(flat_code)
 end if
end procedure


global procedure asm_gouraudtri_ex(sequence triCoords,sequence triCol,atom triAddr)
integer ymin,ymax
 call(reset_minmax_buffers)
 poke4(gouraud_scan_data,{triCoords[1][1],triCoords[2][1],triCoords[1][2],triCoords[2][2],
                  triCol[1],triCol[2]})
 call(gouraud_scan_routine)
 poke4(gouraud_scan_data,{triCoords[2][1],triCoords[3][1],triCoords[2][2],triCoords[3][2],
                  triCol[2],triCol[3]})
 call(gouraud_scan_routine)
 poke4(gouraud_scan_data,{triCoords[3][1],triCoords[1][1],triCoords[3][2],triCoords[1][2],
                  triCol[3],triCol[1]})
 call(gouraud_scan_routine)
 ymin=triCoords[1][2]
 ymax=ymin
 for i=2 to 3 do
  if triCoords[i][2]<ymin then ymin=triCoords[i][2] end if
  if triCoords[i][2]>ymax then ymax=triCoords[i][2] end if
 end for 
 if (ymax>=0 and ymin<render_screenH) then
  if ymin<0 then ymin=0 end if
  if ymax>render_maxH then ymax=render_maxH end if
  poke4(gouraud_numlines,(ymax-ymin)+1)
  poke4(gouraud_y,ymin)
  poke4(gouraud_scraddr,triAddr)
  call(gouraud_hlines)
 end if
end procedure


global procedure asm_texturetri_ex(sequence triCoords,sequence texCoords,atom texture,integer method,atom triAddr)
integer ymin,ymax
 call(reset_minmax_buffers)
 poke4(stps_data,{triCoords[1][1],triCoords[2][1],triCoords[1][2],triCoords[2][2],
                  texCoords[1][1],texCoords[2][1],texCoords[1][2],texCoords[2][2]})
 call(mapping[method][texScan])
 poke4(stps_data,{triCoords[2][1],triCoords[3][1],triCoords[2][2],triCoords[3][2],
                 texCoords[2][1],texCoords[3][1],texCoords[2][2],texCoords[3][2]})
 call(mapping[method][texScan])
 poke4(stps_data,{triCoords[3][1],triCoords[1][1],triCoords[3][2],triCoords[1][2],
                 texCoords[3][1],texCoords[1][1],texCoords[3][2],texCoords[1][2]})
 call(mapping[method][texScan])
 ymin=triCoords[1][2]
 ymax=ymin
 for i=2 to 3 do
  if triCoords[i][2]<ymin then ymin=triCoords[i][2] end if
  if triCoords[i][2]>ymax then ymax=triCoords[i][2] end if
 end for 
 if (ymax>=0 and ymin<render_screenH) then
  if ymin<0 then ymin=0 end if
  if ymax>render_maxH then ymax=render_maxH end if
  poke4(mapping[method][texNumLines],(ymax-ymin)+1)
  poke4(mapping[method][texY],ymin)
  poke4(mapping[method][texScrAddr],triAddr)
  poke4(mapping[method][texTexture],texture)
  call(mapping[method][texCode])
 end if
end procedure


global procedure asm_quad_ex(sequence quadCoords,integer quadCol,atom quadAddr)
integer ymin,ymax
 call(reset_minmax_buffers)
 poke4(sps_data,{quadCoords[1][1],quadCoords[2][1],quadCoords[1][2],quadCoords[2][2]})
 call(sps_code)
 poke4(sps_data,{quadCoords[2][1],quadCoords[3][1],quadCoords[2][2],quadCoords[3][2]})
 call(sps_code)
 poke4(sps_data,{quadCoords[3][1],quadCoords[4][1],quadCoords[3][2],quadCoords[4][2]})
 call(sps_code)
 poke4(sps_data,{quadCoords[4][1],quadCoords[1][1],quadCoords[4][2],quadCoords[1][2]})
 call(sps_code)
 ymin=quadCoords[1][2]
 ymax=ymin
 for i=2 to 4 do
  if quadCoords[i][2]<ymin then ymin=quadCoords[i][2] end if
  if quadCoords[i][2]>ymax then ymax=quadCoords[i][2] end if
 end for 
 if (ymax>=0 and ymin<render_screenH) then
  if ymin<0 then ymin=0 end if
  if ymax>render_maxH then ymax=render_maxH end if
  poke4(flat_y,ymin)
  poke4(flat_numlines,(ymax-ymin)+1)
  if render_bytesPerPixel=1 then
   poke(flat_color,{quadCol,quadCol,quadCol,quadCol})
  elsif render_bytesPerPixel=3 then
   poke4(flat_color,quadCol)
  else
   poke_word(flat_color,{quadCol,quadCol})
  end if
  poke4(flat_scraddr,quadAddr)
  call(flat_code)
 end if
end procedure


global procedure asm_mixquad_ex(sequence quadCoords,integer quadCol,atom quadAddr)
integer ymin,ymax
 call(reset_minmax_buffers)
 poke4(sps_data,{quadCoords[1][1],quadCoords[2][1],quadCoords[1][2],quadCoords[2][2]})
 call(sps_code)
 poke4(sps_data,{quadCoords[2][1],quadCoords[3][1],quadCoords[2][2],quadCoords[3][2]})
 call(sps_code)
 poke4(sps_data,{quadCoords[3][1],quadCoords[4][1],quadCoords[3][2],quadCoords[4][2]})
 call(sps_code)
 poke4(sps_data,{quadCoords[4][1],quadCoords[1][1],quadCoords[4][2],quadCoords[1][2]})
 call(sps_code)
 ymin=quadCoords[1][2]
 ymax=ymin
 for i=2 to 4 do
  if quadCoords[i][2]<ymin then ymin=quadCoords[i][2] end if
  if quadCoords[i][2]>ymax then ymax=quadCoords[i][2] end if
 end for 
 if (ymax>=0 and ymin<render_screenH) then
  if ymin<0 then ymin=0 end if
  if ymax>render_maxH then ymax=render_maxH end if
  poke4(mixflat_y,ymin)
  poke4(mixflat_numlines,(ymax-ymin)+1)
  if render_bytesPerPixel=1 then
   poke(mixflat_color,{quadCol,quadCol,quadCol,quadCol})
  elsif render_bytesPerPixel=3 then
   poke4(mixflat_color,quadCol)
  else
   poke_word(mixflat_color,{quadCol,quadCol})
  end if
  poke4(mixflat_scraddr,quadAddr)
  call(mixflat_code)
 end if
end procedure


global procedure asm_gouraudquad_ex(sequence quadCoords,sequence quadCol,atom quadAddr)
integer ymin,ymax
 call(reset_minmax_buffers)
 poke4(gouraud_scan_data,{quadCoords[1][1],quadCoords[2][1],quadCoords[1][2],quadCoords[2][2],
                  quadCol[1],quadCol[2]})
 call(gouraud_scan_routine)
 poke4(gouraud_scan_data,{quadCoords[2][1],quadCoords[3][1],quadCoords[2][2],quadCoords[3][2],
                  quadCol[2],quadCol[3]})
 call(gouraud_scan_routine)
 poke4(gouraud_scan_data,{quadCoords[3][1],quadCoords[4][1],quadCoords[3][2],quadCoords[4][2],
                  quadCol[3],quadCol[4]})
 call(gouraud_scan_routine)
 poke4(gouraud_scan_data,{quadCoords[4][1],quadCoords[1][1],quadCoords[4][2],quadCoords[1][2],
                  quadCol[4],quadCol[1]})
 call(gouraud_scan_routine)
 ymin=quadCoords[1][2]
 ymax=ymin
 for i=2 to 4 do
  if quadCoords[i][2]<ymin then ymin=quadCoords[i][2] end if
  if quadCoords[i][2]>ymax then ymax=quadCoords[i][2] end if
 end for 
 if (ymax>=0 and ymin<render_screenH) then
  if ymin<0 then ymin=0 end if
  if ymax>render_maxH then ymax=render_maxH end if
  poke4(gouraud_numlines,(ymax-ymin)+1)
  poke4(gouraud_y,ymin)
  poke4(gouraud_scraddr,quadAddr)
  call(gouraud_hlines)
 end if
end procedure


global procedure asm_mixgouraudquad_ex(sequence quadCoords,sequence quadCol,atom quadAddr)
integer ymin,ymax
 call(reset_minmax_buffers)
 poke4(gouraud_scan_data,{quadCoords[1][1],quadCoords[2][1],quadCoords[1][2],quadCoords[2][2],
                  quadCol[1],quadCol[2]})
 call(gouraud_scan_routine)
 poke4(gouraud_scan_data,{quadCoords[2][1],quadCoords[3][1],quadCoords[2][2],quadCoords[3][2],
                  quadCol[2],quadCol[3]})
 call(gouraud_scan_routine)
 poke4(gouraud_scan_data,{quadCoords[3][1],quadCoords[4][1],quadCoords[3][2],quadCoords[4][2],
                  quadCol[3],quadCol[4]})
 call(gouraud_scan_routine)
 poke4(gouraud_scan_data,{quadCoords[4][1],quadCoords[1][1],quadCoords[4][2],quadCoords[1][2],
                  quadCol[4],quadCol[1]})
 call(gouraud_scan_routine)
 ymin=quadCoords[1][2]
 ymax=ymin
 for i=2 to 4 do
  if quadCoords[i][2]<ymin then ymin=quadCoords[i][2] end if
  if quadCoords[i][2]>ymax then ymax=quadCoords[i][2] end if
 end for 
 if (ymax>=0 and ymin<render_screenH) then
  if ymin<0 then ymin=0 end if
  if ymax>render_maxH then ymax=render_maxH end if
  if render_bytesPerPixel=1 then
   poke4(ghl_mix_lup,rMixTb)
  end if
  poke4(mixgouraud_numlines,(ymax-ymin)+1)
  poke4(mixgouraud_y,ymin)
  poke4(mixgouraud_scraddr,quadAddr)
  call(mixgouraud_hlines)
 end if
end procedure


global procedure asm_texturequad_ex(sequence quadCoords,sequence texCoords,atom texture,integer method,atom quadAddr)
integer ymin,ymax
 call(reset_minmax_buffers)
 poke4(stps_data,{quadCoords[1][1],quadCoords[2][1],quadCoords[1][2],quadCoords[2][2],
                  texCoords[1][1],texCoords[2][1],texCoords[1][2],texCoords[2][2]})
 call(mapping[method][texScan])
 poke4(stps_data,{quadCoords[2][1],quadCoords[3][1],quadCoords[2][2],quadCoords[3][2],
                 texCoords[2][1],texCoords[3][1],texCoords[2][2],texCoords[3][2]})
 call(mapping[method][texScan])
 poke4(stps_data,{quadCoords[3][1],quadCoords[4][1],quadCoords[3][2],quadCoords[4][2],
                 texCoords[3][1],texCoords[4][1],texCoords[3][2],texCoords[4][2]})
 call(mapping[method][texScan])
 poke4(stps_data,{quadCoords[4][1],quadCoords[1][1],quadCoords[4][2],quadCoords[1][2],
                  texCoords[4][1],texCoords[1][1],texCoords[4][2],texCoords[1][2]})
 call(mapping[method][texScan])
 ymin=quadCoords[1][2]
 ymax=ymin
 for i=2 to 4 do
  if quadCoords[i][2]<ymin then ymin=quadCoords[i][2] end if
  if quadCoords[i][2]>ymax then ymax=quadCoords[i][2] end if
 end for 
 if (ymax>=0 and ymin<render_screenH) then
  if ymin<0 then ymin=0 end if
  if ymax>render_maxH then ymax=render_maxH end if
  --poke4(thl_mix_lup,rMixTb)
  poke4(mapping[method][texNumLines],(ymax-ymin)+1)
  poke4(mapping[method][texY],ymin)
  poke4(mapping[method][texScrAddr],quadAddr)
  poke4(mapping[method][texTexture],texture)
  call(mapping[method][texCode])
 end if
end procedure



global procedure asm_polygon_ex(sequence polyCoords,integer polyCol,atom polyAddr)
integer ymin,ymax
integer vertexes
 call(reset_minmax_buffers)
 vertexes=length(polyCoords)
 for i=1 to (vertexes-1) do
  poke4(sps_data,{polyCoords[i][1],polyCoords[i+1][1],polyCoords[i][2],polyCoords[i+1][2]})
  call(sps_code)
 end for
 poke4(sps_data,{polyCoords[vertexes][1],polyCoords[1][1],polyCoords[vertexes][2],polyCoords[1][2]})
 call(sps_code)
 ymin=polyCoords[1][2]
 ymax=ymin
 for i=2 to vertexes do
  if polyCoords[i][2]<ymin then ymin=polyCoords[i][2] end if
  if polyCoords[i][2]>ymax then ymax=polyCoords[i][2] end if
 end for 
 if (ymax>=0 and ymin<render_screenH) then
  if ymin<0 then ymin=0 end if
  if ymax>render_maxH then ymax=render_maxH end if
  poke4(flat_y,ymin)
  poke4(flat_numlines,(ymax-ymin)+1)
   if render_bytesPerPixel=1 then
   poke(flat_color,{polyCol,polyCol,polyCol,polyCol})
  elsif render_bytesPerPixel=3 then
   poke4(flat_color,polyCol)
  else
   poke_word(flat_color,{polyCol,polyCol})
  end if
  poke4(flat_scraddr,polyAddr)
  call(flat_code)
 end if
end procedure


global procedure asm_gouraudpolygon_ex(sequence polyCoords,sequence polyCol,atom polyAddr)
integer ymin,ymax
integer vertexes
 call(reset_minmax_buffers)
 vertexes=length(polyCoords)
 for i=1 to (vertexes-1) do
  poke4(gouraud_scan_data,{polyCoords[i][1],polyCoords[i+1][1],polyCoords[i][2],polyCoords[i+1][2],
                   polyCol[i],polyCol[i+1]})
  call(gouraud_scan_routine)
 end for
 poke4(gouraud_scan_data,{polyCoords[vertexes][1],polyCoords[1][1],polyCoords[vertexes][2],polyCoords[1][2],
                  polyCol[vertexes],polyCol[1]})
 call(gouraud_scan_routine)
 ymin=polyCoords[1][2]
 ymax=ymin
 for i=2 to vertexes do
  if polyCoords[i][2]<ymin then ymin=polyCoords[i][2] end if
  if polyCoords[i][2]>ymax then ymax=polyCoords[i][2] end if
 end for 
 if (ymax>=0 and ymin<render_screenH) then
  if ymin<0 then ymin=0 end if
  if ymax>render_maxH then ymax=render_maxH end if
  poke4(gouraud_numlines,(ymax-ymin)+1)
  poke4(gouraud_y,ymin)
  poke4(gouraud_scraddr,polyAddr)
  call(gouraud_hlines)
 end if
end procedure


global procedure asm_texturepolygon_ex(sequence polyCoords,sequence texCoords,atom texture,integer method,atom polyAddr)
integer ymin,ymax
integer vertexes
 call(reset_minmax_buffers)
 vertexes=length(polyCoords)
 for i=1 to (vertexes-1) do
  poke4(stps_data,{polyCoords[i][1],polyCoords[i+1][1],polyCoords[i][2],polyCoords[i+1][2],
                   texCoords[i][1],texCoords[i+1][1],texCoords[i][2],texCoords[i+1][2]})
  call(mapping[method][texScan])
 end for
 poke4(stps_data,{polyCoords[vertexes][1],polyCoords[1][1],polyCoords[vertexes][2],polyCoords[1][2],
                 texCoords[vertexes][1],texCoords[1][1],texCoords[vertexes][2],texCoords[1][2]})
 call(mapping[method][texScan])
 ymin=polyCoords[1][2]
 ymax=ymin
 for i=2 to vertexes do
  if polyCoords[i][2]<ymin then ymin=polyCoords[i][2] end if
  if polyCoords[i][2]>ymax then ymax=polyCoords[i][2] end if
 end for 
 if (ymax>=0 and ymin<render_screenH) then
  if ymin<0 then ymin=0 end if
  if ymax>render_maxH then ymax=render_maxH end if
  poke4(mapping[method][texNumLines],(ymax-ymin)+1)
  poke4(mapping[method][texY],ymin)
  poke4(mapping[method][texScrAddr],polyAddr)
  poke4(mapping[method][texTexture],texture)
  call(mapping[method][texCode])
 end if
end procedure


--** </Main routines> **--

global function tile_texture(sequence tex,integer bpp)
integer bytesPP,dst
atom Tiled
 bytesPP=floor((bpp+1)/8)
 Tiled=allocate((256*256*bytesPP))
 if Tiled<=0 then
  return -1
 end if
 if bytesPP=1 then
  for v=0 to 255 do
   for u=0 to 255 do
    dst=and_bits((u*256),#F800)+and_bits(u,7)+and_bits((v*8),#07F8)
    poke(Tiled+dst,peek(tex[1]+(v*256)+u))
   end for
  end for
 elsif bytesPP=2 then
  for v=0 to 255 do
   for u=0 to 255 do
    dst=and_bits((u*256),#F800)+and_bits(u,7)+and_bits((v*8),#07F8)
    poke_word(Tiled+(dst*2),peek_word(tex[1]+(v*512)+(u*2)))
   end for
  end for
 elsif bytesPP=3 then
  for v=0 to 255 do
   for u=0 to 255 do
    dst=and_bits((u*256),#F800)+and_bits(u,7)+and_bits((v*8),#07F8)
    poke3(Tiled+(dst*3),peek3(tex[1]+(v*768)+(u*3)))
   end for
  end for
 end if
 free(tex[1])
 return {Tiled,tex[2],tex[3]}
end function


global procedure clear_area(atom dest,integer col,sequence coords)
integer len
 len=((coords[2][1]-coords[1][1])+1)*render_bytesPerPixel
 for i=coords[1][2] to coords[2][2] do
  mem_set(dest+(i*render_screenW*render_bytesPerPixel)+(coords[1][1]*render_bytesPerPixel),col,len)
 end for
end procedure


constant cls_code=get_asm(
"pusha cld "&
"mov edi,cls_dest "&
"mov eax,cls_col "&
"mov ecx,[cls_iterations] "&
"rep stosd "&
"popa ret")
constant cls_dest=cls_code+get_param("cls_dest")
constant cls_col=cls_code+get_param("cls_col")
resolve_param("cls_iterations",rClsIter)

global procedure cls(atom dest,integer col)
 poke4(cls_dest,dest)
 if render_bytesPerPixel=1 then
  poke(cls_col,{col,col,col,col})
 elsif render_bytesPerPixel=2 then
  poke_word(cls_col,{col,col})
 else
  poke4(cls_col,col)
 end if
 call(cls_code)
end procedure












constant fcopy_code=get_asm(
"pusha cld "&
"mov edi,fcopy_dest "&
"mov esi,fcopy_src "&
"add edi,[fcopy_screenSize] "&
"add esi,[fcopy_screenSize] "&
"mov ecx,[fcopy_iterations] "&
"fcopy_@loop: "&
"fild qword ptr [esi + ecx*8] "&
"fistp qword ptr [edi + ecx*8] "&
"inc ecx "&
"fild qword ptr [esi + ecx*8] "&
"fistp qword ptr [edi + ecx*8] "&
"inc ecx "&
"fild qword ptr [esi + ecx*8] "&
"fistp qword ptr [edi + ecx*8] "&
"inc ecx "&
"fild qword ptr [esi + ecx*8] "&
"fistp qword ptr [edi + ecx*8] "&
"inc ecx "&
"jnz fcopy_@loop "&
"popa ret ")
constant fcopy_dest=fcopy_code+get_param("fcopy_dest")
constant fcopy_src=fcopy_code+get_param("fcopy_src")
resolve_param("fcopy_screenSize",rBytesOnScreen)
resolve_param("fcopy_iterations",rFCopyIter)

global procedure fcopy_screen(atom dest,atom src)
 poke4(fcopy_src,src)
 poke4(fcopy_dest,dest)
 call(fcopy_code)
end procedure


constant fcls_code=get_asm(
"pusha cld "&
"mov edi,fcls_dest "&
"add edi,[fcls_screenSize] "&
"mov ecx,[fcls_iterations] "&
"fldz "&
"fcls_@loop: "&
"fst qword ptr [edi + ecx*8] "&
"inc ecx "&
"jnz fcls_@loop "&
"mov eax,-8 "&
"fstp qword ptr [edi + eax] "&
"popa ret ")
constant fcls_dest=fcls_code+get_param("fcls_dest")
resolve_param("fcls_screenSize",rBytesOnScreen)
resolve_param("fcls_iterations",rFCopyIter)

global procedure fcls(atom dest)
 poke4(fcls_dest,dest)
 call(fcls_code)
end procedure


global function render_mode(integer w,integer h,integer bpp)
 if (w<=1024) then
  if (h<=768) then
   render_screenW=w
   render_maxW=w-1
   render_screenH=h
   render_maxH=h-1
   render_bytesPerPixel=floor((bpp+1)/8)
   poke4(rScreenW,render_screenW)
   poke4(rMaxW,render_maxW)
   poke4(rScreenH,render_screenH)
   poke4(rMaxH,render_maxH)
   poke4(rBytesOnScreen,(w*h*render_bytesPerPixel))
   poke4(rFCopyIter,-(floor((w*h*render_bytesPerPixel)/8)))
   poke4(rClsIter,floor((w*h*render_bytesPerPixel)/4))
   if bpp=8 then
    flat_y=hl_y
    flat_numlines=hl_numlines
    flat_scraddr=hl_scraddr
    flat_color=hl_color
    flat_code=hl_code
    --poke4(rFlatCode,drawsection8)
    gouraud_scan_routine=sgps_code
    gouraud_scan_data=sgps_data
    gouraud_hlines=ghl_code
    gouraud_y=ghl_y
    gouraud_numlines=ghl_numlines
    gouraud_scraddr=ghl_scraddr
    mixgouraud_hlines=ghl_mix_code
    mixgouraud_y=ghl_mix_y
    mixgouraud_numlines=ghl_mix_numlines
    mixgouraud_scraddr=ghl_mix_scraddr
    if render_clipping then
     mapping[REGULAR]={thl_clip_y,thl_clip_numlines,thl_clip_scraddr,thl_clip_texture,thl_clip_code,stps_code}
    else
     mapping[REGULAR]={thl_y,thl_numlines,thl_scraddr,thl_texture,thl_code,stps_code}
    end if
    mapping[MIXED]={thl_mix_y,thl_mix_numlines,thl_mix_scraddr,thl_mix_texture,thl_mix_code,stps_code}
    mapping[TILED]={thl_tile_y,thl_tile_numlines,thl_tile_scraddr,thl_tile_texture,thl_tile_code,stps_tile_code}
   elsif (bpp=16) or (bpp=15) then
    flat_y=hl1516_y
    flat_numlines=hl1516_numlines
    flat_scraddr=hl1516_scraddr
    flat_color=hl1516_color
    flat_code=hl1516_code
    --poke4(rFlatCode,drawsection8)
    mapping[REGULAR]={thl1516_y,thl1516_numlines,thl1516_scraddr,thl1516_texture,thl1516_code,stps_code}
    mapping[TILED]={thl1516_tile_y,thl1516_tile_numlines,thl1516_tile_scraddr,thl1516_tile_texture,thl1516_tile_code,stps_tile_code}
    if bpp=16 then
     mixflat_y=hl16_mix_y
     mixflat_numlines=hl16_mix_numlines
     mixflat_scraddr=hl16_mix_scraddr
     mixflat_color=hl16_mix_color
     mixflat_code=hl16_mix_code
     gouraud_scan_routine=sgps16_code
     gouraud_scan_data=sgps16_data
     gouraud_hlines=ghl16_code
     gouraud_y=ghl16_y
     gouraud_numlines=ghl16_numlines
     gouraud_scraddr=ghl16_scraddr
     mapping[MIXED]={thl16_mix_y,thl16_mix_numlines,thl16_mix_scraddr,thl16_mix_texture,thl16_mix_code,stps_code}
    else
     gouraud_scan_routine=sgps15_code
     gouraud_scan_data=sgps16_data
     gouraud_hlines=ghl15_code
     gouraud_y=ghl15_y
     gouraud_numlines=ghl15_numlines
     gouraud_scraddr=ghl15_scraddr
     mapping[MIXED]={thl15_mix_y,thl15_mix_numlines,thl15_mix_scraddr,thl15_mix_texture,thl15_mix_code,stps_code}
    end if 
   elsif (bpp=24) then
    flat_y=hl24_y
    flat_numlines=hl24_numlines
    flat_scraddr=hl24_scraddr
    flat_color=hl24_color
    flat_code=hl24_code
    gouraud_scan_routine=sgps24_code
    gouraud_scan_data=sgps16_data
    gouraud_hlines=ghl24_code
    gouraud_y=ghl24_y
    gouraud_numlines=ghl24_numlines
    gouraud_scraddr=ghl24_scraddr
    --poke4(rFlatCode,drawsection8)
    mapping[REGULAR]={thl24_y,thl24_numlines,thl24_scraddr,thl24_texture,thl24_code,stps_code}
    mapping[MIXED]={thl24_mix_y,thl24_mix_numlines,thl24_mix_scraddr,thl24_mix_texture,thl24_mix_code,stps_code}
    mapping[TILED]={thl24_tile_y,thl24_tile_numlines,thl24_tile_scraddr,thl24_tile_texture,thl24_tile_code,stps_tile_code}
   end if
   return 0
  else
   return 1
  end if
 else
  return 1
 end if
end function


global procedure render_clip(integer turn_it_on)
 if turn_it_on then
  render_clipping=1
 else
  render_clipping=0
 end if
end procedure



